/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.31 from the
 * contents of API.xs. Do not edit this file, edit API.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

/******************************************************************************
 * $Id: API.xs,v 1.18.2.14 2010/08/03 20:27:49 nkinder%redhat.com Exp $
 *
 * ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is PerLDAP. 
 *
 * The Initial Developer of the Original Code is
 * Netscape Communications Corporation. and Clayton Donley.
 * Portions created by the Initial Developer are Copyright (C) 2001
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   - Leif Hedstrom <leif@perldap.org>
 *   - Kevin McCarthy
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

/*
 * DESCRIPTION
 *    This is the XSUB interface for the API.
 */
 
#ifdef __cplusplus
extern "C" {
#endif

/* Perl Include Files */
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#ifdef __cplusplus
}
#endif

/* LDAP C SDK Include Files */
#include <lber.h>
#include <ldap.h>

/* need to define ber types for old version of api */
#if LDAP_VENDOR_VERSION < 600
typedef int my_chgtype_t;
typedef long my_chgnum_t;
typedef unsigned long my_result_t;
typedef unsigned long my_vlvint_t;
#else
typedef ber_int_t my_chgtype_t;
typedef ber_int_t my_chgnum_t;
typedef ber_int_t my_result_t;
typedef ber_int_t my_vlvint_t;
#endif /* LDAP_VENDOR_VERSION < 600 */

/* SSL is only available in Binary */
#ifdef USE_SSL
#ifndef USE_OPENLDAP
# include <ldap_ssl.h>
#endif
#endif

/* AUTOLOAD methods for LDAP constants */
#include "constant.h"

/* This stuff is needed when using OpenLDAP.  Most of it is taken
 * from the Mozilla LDAP C SDK. */
#ifdef USE_OPENLDAP
#define LDAP_C
#define LDAP_CALL
#define LDAP_CALLBACK

/* Stuff for sorting entries */
typedef int (LDAP_C LDAP_CALLBACK LDAP_CMP_CALLBACK)(const char *val1, const char *val2);

typedef int (LDAP_C LDAP_CALLBACK LDAP_CHARCMP_CALLBACK)(char*, char*);

static LDAP_CHARCMP_CALLBACK *perldap_et_cmp_fn;

struct entrything {
        char            **et_vals;
        LDAPMessage     *et_msg;
};

typedef LDAPSortKey LDAPsortkey;

#define LDAP_TAG_SK_MATCHRULE   0x80L   /* context specific + primitive + 0 */
#define LDAP_TAG_SK_REVERSE     0x81L   /* context specific + primitive + 1 */

/* VLV structure */
typedef struct ldapvirtuallist {
    ber_int_t   ldvlist_before_count;       /* # entries before target */
    ber_int_t   ldvlist_after_count;        /* # entries after target */
    char        *ldvlist_attrvalue;         /* jump to this value */
    ber_int_t   ldvlist_index;              /* list offset */
    ber_int_t   ldvlist_size;               /* number of items in vlist */
    void        *ldvlist_extradata;         /* for use by application */
} LDAPVirtualList;

/* We don't really need/use these, but we need to define them
 * to something to prevent compiler errors. */
typedef char FriendlyMap;
typedef char LDAPFiltDesc;
typedef char LDAPFiltInfo;
typedef char LDAPMemCache;
typedef char LDAPVersion;
#endif

/* Prototypes */
static int perldap_init();

static void * perldap_malloc(size_t size);

static void * perldap_calloc(size_t number, size_t size);

static void * perldap_realloc(void *ptr, size_t size);

static void perldap_free(void *ptr);

static int perldap_et_cmp(const void  *aa, const void  *bb);

static void perldap_ldap_value_free(char **vals);

static int perldap_ldap_create_persistentsearch_control(LDAP *ld, int changetypes,
    int changesonly, int return_echg_ctrls, char ctrl_iscritical, LDAPControl **ctrlp);

static int perldap_ldap_create_sort_control(LDAP *ld, LDAPsortkey **sortKeyList,
                                            char ctrl_iscritical, LDAPControl **ctrlp);

static int perldap_ldap_create_virtuallist_control(LDAP *ld, LDAPVirtualList *ldvlistp,
                                                   LDAPControl **ctrlp);

static int perldap_ldap_multisort_entries(LDAP *ld, LDAPMessage **chain,
                                          char **attrs, LDAP_CMP_CALLBACK *cmp);

static int perldap_ldap_parse_entrychange_control(LDAP *ld, LDAPControl **ctrls,
                   ber_int_t *chgtypep, char **prevdnp, int *chgnumpresentp, ber_int_t *chgnump);

static int perldap_ldap_parse_sort_control(LDAP *ld, LDAPControl **ctrls,
                                      ber_int_t *result, char **attribute);

static int perldap_ldap_parse_virtuallist_control(LDAP *ld, LDAPControl **ctrls,
                    ber_int_t *target_posp, ber_int_t *list_sizep, int *errcodep);

static void perldap_ldap_perror(LDAP *ld, const char *s);

static int perldap_ldap_set_lderrno(LDAP *ld, int e, char *m, char *s);

static int perldap_ldap_sort_entries(LDAP *ld, LDAPMessage **chain, char *attr,
                                     LDAP_CMP_CALLBACK *cmp);

static int perldap_ldap_url_search(LDAP *ld, char *url, int attrsonly);

static int perldap_ldap_url_search_s(LDAP *ld, char *url, int attrsonly, LDAPMessage **res);

static int perldap_ldap_url_search_st(LDAP *ld, char *url, int attrsonly,
                                      struct timeval *timeout, LDAPMessage **res);

static int perldap_ldapssl_client_init(const char *certdbpath, void *certdbhandle);

static int perldap_ldapssl_enable_clientauth(LDAP *ld, char *keynickname,
                                  char *keypasswd, char *certnickname);

static LDAP * perldap_ldapssl_init(const char *host, const char *port, int secure);

static char ** avref2charptrptr(SV *avref);

static struct berval ** avref2berptrptr(SV *avref);

static SV* charptrptr2avref(char **cppval);

static SV* berptrptr2avref(struct berval **bval);

static LDAPMod *parse1mod(SV *ldap_value_ref,char *ldap_current_attribute,
                int ldap_add_func,int cont);

static int calc_mod_size(HV *ldap_change);

static LDAPMod **hash2mod(SV *ldap_change_ref,int ldap_add_func,const char *func);

static int StrCaseCmp(const char *s, const char *t);

static char * StrDup(const char *source);

#ifdef USE_OPENLDAP
static int LDAP_CALL internal_rebind_proc(LDAP *ld, LDAP_CONST char *url,
            ber_tag_t request, ber_int_t msgid, void *arg);

static int LDAP_CALL ldap_default_rebind_proc(LDAP *ld, LDAP_CONST char *url,
            ber_tag_t request, ber_int_t msgid, void *arg);
#else
static int LDAP_CALL internal_rebind_proc(LDAP *ld,char **dnp,char **pwp,
            int *authmethodp,int freeit,void *arg);

static int LDAP_CALL ldap_default_rebind_proc(LDAP *ld, char **dn, char **pswd,
            int *auth, int freeit, void *arg);
#endif


/* Global Definitions and Variables */
SV *ldap_perl_rebindproc = NULL;

static char *ldap_default_rebind_dn = NULL;
static char *ldap_default_rebind_pwd = NULL;
static int ldap_default_rebind_auth = LDAP_AUTH_SIMPLE;

SV *ldap_perl_sortcmp = NULL;

/* Return a Perl List from a char ** in PPCODE */
#define RET_CPP(cppvar) \
	   int cppindex; \
	   if (cppvar) { \
	   for (cppindex = 0; cppvar[cppindex] != NULL; cppindex++) \
	   { \
	      EXTEND(sp,1); \
	      PUSHs(sv_2mortal(newSVpv(cppvar[cppindex],strlen(cppvar[cppindex])))); \
	   } \
	   perldap_ldap_value_free(cppvar); }

/* Return a Perl List from a berval ** in PPCODE */
#define RET_BVPP(bvppvar) \
	   int bvppindex; \
	   if (bvppvar) { \
	   for (bvppindex = 0; bvppvar[bvppindex] != NULL; bvppindex++) \
	   { \
	      EXTEND(sp,1); \
	      PUSHs(sv_2mortal(newSVpv(bvppvar[bvppindex]->bv_val,bvppvar[bvppindex]->bv_len))); \
	   } \
	   ldap_value_free_len(bvppvar); }


/*
 * Function Definition
 */

static
int
perldap_init()
{
#ifdef USE_OPENLDAP
   /* OpenLDAP doesn't allow us to set our
    * own memory allocation functions. */
   return LDAP_OPT_SUCCESS;
#else
   struct ldap_memalloc_fns memalloc_fns;

   memalloc_fns.ldapmem_malloc = perldap_malloc;
   memalloc_fns.ldapmem_calloc = perldap_calloc;
   memalloc_fns.ldapmem_realloc = perldap_realloc;
   memalloc_fns.ldapmem_free = perldap_free;

   return (ldap_set_option(NULL,
                           LDAP_OPT_MEMALLOC_FN_PTRS,
                           &memalloc_fns));
#endif
}


static
void *
perldap_malloc(size_t size)
{
   void *new_ptr;

   New(1, new_ptr, size, char);

   return (new_ptr);
}

static
void *
perldap_calloc(size_t number, size_t size)
{
   void *new_ptr;

   Newz(1, new_ptr, (number*size), char);

   return (new_ptr);
}

static
void *
perldap_realloc(void *ptr, size_t size)
{
   Renew(ptr, size, char);

   return (ptr);
}

static
void
perldap_free(void *ptr)
{
   Safefree(ptr);
}

/* Helpers for using different LDAP libraries */
static
void
perldap_ldap_value_free(char **vals)
{
#ifdef USE_OPENLDAP
   char    **a;

    if ( vals == NULL ) {
        return;
    }

    for (a = vals; *a != NULL; a++)
    {
        char *tmp= *a;
        ldap_memfree((void *)tmp);
    }
    ldap_memfree((void *)vals);
#else
   ldap_value_free(vals);
#endif
}

static
int
perldap_ldap_create_persistentsearch_control(LDAP *ld, int changetypes,
    int changesonly, int return_echg_ctrls, char ctrl_iscritical, LDAPControl **ctrlp)
{
    int ret = 0;

#ifdef USE_OPENLDAP
    BerElement *        ber = NULL;
    struct berval *     berval = NULL;

    if (ctrlp == NULL || (changetypes & ~(LDAP_CONTROL_PERSIST_ENTRY_CHANGE_ADD |
        LDAP_CONTROL_PERSIST_ENTRY_CHANGE_DELETE | LDAP_CONTROL_PERSIST_ENTRY_CHANGE_MODIFY |
        LDAP_CONTROL_PERSIST_ENTRY_CHANGE_RENAME)) != 0) {
        ret = LDAP_PARAM_ERROR;
        goto bail;
    }

    if ((ber = ber_alloc_t(LBER_USE_DER)) == NULL) {
        ret = LDAP_NO_MEMORY;
        goto bail;
    }

    if (ber_printf(ber, "{ibb}", changetypes, changesonly, return_echg_ctrls) == -1) {
        ret = LDAP_ENCODING_ERROR;
        goto bail;
    }

    if (ber_flatten(ber, &berval) != LDAP_SUCCESS) {
        ret = LDAP_NO_MEMORY;
        goto bail;
    }

    ret = ldap_control_create(LDAP_CONTROL_PERSIST_REQUEST,
                              ctrl_iscritical, berval, 1, ctrlp);

bail:
    ber_free(ber, 1);
    ber_bvfree(berval);
    ldap_set_option(ld, LDAP_OPT_RESULT_CODE, &ret);
#else
    ret = ldap_create_persistentsearch_control(ld, changetypes, changesonly,
                                  return_echg_ctrls, ctrl_iscritical, ctrlp);
#endif

    return ret;
}

static
int
perldap_ldap_create_sort_control(LDAP *ld, LDAPsortkey **sortKeyList,
        char ctrl_iscritical, LDAPControl **ctrlp)
{
    int ret = 0;

#ifdef USE_OPENLDAP
    BerElement *        ber = NULL;
    struct berval *     berval = NULL;
    int i = 0;

    if ( sortKeyList == NULL || ctrlp == NULL ) {
        ret = LDAP_PARAM_ERROR;
        goto bail;
    }

    if ((ber = ber_alloc_t(LBER_USE_DER)) == NULL) {
        ret = LDAP_NO_MEMORY;
        goto bail;
    }

    if (ber_printf(ber, "{") == -1) {
        ret = LDAP_ENCODING_ERROR;
        goto bail;
    }

    for(i = 0; sortKeyList[i] != NULL; i++) {
        if (ber_printf(ber, "{s", (sortKeyList[i])->attributeType) == -1) {
            ret = LDAP_ENCODING_ERROR;
            goto bail;
        }

        if ((sortKeyList[i])->orderingRule != NULL ) {
            if (ber_printf(ber, "ts", LDAP_TAG_SK_MATCHRULE,
                            (sortKeyList[i])->orderingRule) == -1) {
                ret = LDAP_ENCODING_ERROR;
                goto bail;
            }
        }

        if ((sortKeyList[i])->reverseOrder) {
            if (ber_printf(ber, "tb}", LDAP_TAG_SK_REVERSE,
                           (sortKeyList[i])->reverseOrder) == -1) {
                ret = LDAP_ENCODING_ERROR;
                goto bail;
            }
        } else {
            if (ber_printf( ber, "}") == -1) {
                ret = LDAP_ENCODING_ERROR;
                goto bail;
            }
        }
    }

    if (ber_printf(ber, "}") == -1) {
        ret = LDAP_ENCODING_ERROR;
        goto bail;
    }

    if (ber_flatten(ber, &berval) != LDAP_SUCCESS) {
        ret = LDAP_NO_MEMORY;
        goto bail;
    }

    ret = ldap_control_create(LDAP_CONTROL_SORTREQUEST,
                              ctrl_iscritical, berval, 1, ctrlp);

bail:
    ber_free(ber, 1);
    ber_bvfree(berval);
    ldap_set_option(ld, LDAP_OPT_RESULT_CODE, &ret);
#else
    ret = ldap_create_sort_control(ld, sortKeyList, ctrl_iscritical, ctrlp);
#endif

    return ret;
}

static
int
perldap_ldap_create_virtuallist_control(LDAP *ld, LDAPVirtualList *ldvlistp, LDAPControl **ctrlp)
{
    int ret = 0;

#ifdef USE_OPENLDAP
    LDAPVLVInfo ldvlvinfo;
    struct berval attrvalue;

    ldvlvinfo.ldvlv_before_count = ldvlistp->ldvlist_before_count;
    ldvlvinfo.ldvlv_after_count = ldvlistp->ldvlist_after_count;
    ldvlvinfo.ldvlv_offset = ldvlistp->ldvlist_index;
    ldvlvinfo.ldvlv_count = ldvlistp->ldvlist_size;

    if (ldvlistp->ldvlist_attrvalue) {
        attrvalue.bv_val = ldvlistp->ldvlist_attrvalue;
        attrvalue.bv_len = strlen(ldvlistp->ldvlist_attrvalue);
        ldvlvinfo.ldvlv_attrvalue = &attrvalue;
    }

    ret = ldap_create_vlv_control(ld, &ldvlvinfo, ctrlp);
#else
    ret = ldap_create_virtuallist_control(ld, ldvlistp, ctrlp);
#endif

    return ret;
}

static
int
perldap_ldap_multisort_entries(LDAP *ld, LDAPMessage **chain,
                          char **attrs, LDAP_CMP_CALLBACK *cmp)
{
/* OpenLDAP doesn't implement any sort functions.  This code is
 * largely borrowed from MozLDAP. */
#ifdef USE_OPENLDAP
    int i, count;
    struct entrything *et;
    LDAPMessage *e, *last;
    LDAPMessage **ep;

    if (ld == NULL || chain == NULL || cmp == NULL) {
        return( LDAP_PARAM_ERROR );
    }

    count = ldap_count_entries( ld, *chain );

    if (count < 0) { /* error, usually with bad ld or malloc */
        return( LDAP_PARAM_ERROR );
    }

    if (count < 2) { /* nothing to sort */
        return( 0 );
    }

    if ( (et = (struct entrything *)perldap_malloc( count *
        sizeof(struct entrything) )) == NULL ) {
        perldap_ldap_set_lderrno(ld, LDAP_NO_MEMORY, NULL, NULL);
        return( -1 );
    }

    e = ldap_first_message(ld, *chain);
    for ( i = 0; i < count; i++ ) {
        et[i].et_msg = e;
        et[i].et_vals = NULL;
        if ( attrs == NULL ) {
            char    *dn;

            dn = ldap_get_dn( ld, e );
            et[i].et_vals = ldap_explode_dn( dn, 1 );
            perldap_free( dn );
        } else {
            int     attrcnt;
            struct berval    **bvals;

            for ( attrcnt = 0; attrs[attrcnt] != NULL; attrcnt++ ) {
                bvals = ldap_get_values_len( ld, e, attrs[attrcnt] );
                if (bvals && bvals[0]) {
                    int bv_count = 0;
                    int j = 0;

                    /* Count the number of bvals we have. */
                    for (bv_count = 0; bvals[bv_count]; bv_count++) {
                        ;
                    }

                    /* Advance to the end of et_vals. */
                    for (j = 0; et[i].et_vals[j]; j++) {
                        ;
                    }

                    /* Realloc et_vals so we can append values from bvals. */
                    et[i].et_vals = (char **)perldap_realloc((char *)et[i].et_vals,
                                               sizeof(char *) * (j + bv_count + 1));

                    /* Copy vals from bvals to et_vals. */
                    for (bv_count = 0; bvals[bv_count]; bv_count++) {
                        et[i].et_vals[j + bv_count] = StrDup(bvals[bv_count]->bv_val);
                    }

                    /* Null terminate the array. */
                    et[i].et_vals[j + bv_count] = 0;

                    /* The values form bvals have been copied, so we can free bvals now. */
                    ldap_value_free_len(bvals);
                }
            }
        }

        e = ldap_next_message(ld, e);
    }
    last = e;

    perldap_et_cmp_fn = (LDAP_CHARCMP_CALLBACK *)cmp;
    qsort( (void *) et, (size_t) count,
            (size_t) sizeof(struct entrything), perldap_et_cmp );

    ep = chain;

    for ( i = 0; i < count; i++ ) {
        *ep = et[i].et_msg;
        e = ldap_next_message(ld, *ep);
        ep = &e;

        perldap_ldap_value_free( et[i].et_vals );
    }
    *ep = last;
    perldap_free((char *) et);

    return( 0 );
#else
    return(ldap_multisort_entries(ld, chain, attrs, cmp));
#endif
}

static
int
perldap_ldap_parse_entrychange_control(LDAP *ld, LDAPControl **ctrls, ber_int_t *chgtypep,
                                 char **prevdnp, int *chgnumpresentp, ber_int_t *chgnump)
{
    int ret = 0;

#ifdef USE_OPENLDAP
    LDAPControl *entchg_control = NULL;

    if ((entchg_control = ldap_control_find(LDAP_CONTROL_PERSIST_ENTRY_CHANGE_NOTICE,
                                            ctrls, NULL)) != NULL) {
        BerElement *ber = NULL;
        ber_int_t changetype;
        ber_len_t len;
        char *previousdn;

        ber = ber_init(&entchg_control->ldctl_value);
        if (ber == NULL) {
            ret = LDAP_NO_MEMORY;
        }

        /* Get the changetype first. */
        if ( ber_scanf( ber, "{e", &changetype ) == LBER_ERROR ) {
            ber_free( ber, 1 );
            ret = LDAP_DECODING_ERROR;
            goto bail;
        }

        /* If this is a MODDN, get the previous DN. */
        if (changetype == LDAP_CONTROL_PERSIST_ENTRY_CHANGE_RENAME) {
            if ( ber_scanf( ber, "a", &previousdn ) == LBER_ERROR ) {
                ber_free( ber, 1 );
                ret = LDAP_DECODING_ERROR;
                goto bail;
            }
        } else {
            previousdn = NULL;
        }

        /* Set the return pointers for the changetype and previous DN. */
        if ( chgtypep != NULL ) {
            *chgtypep = changetype;
        }
        if ( prevdnp != NULL ) {
            *prevdnp = previousdn;
        } else if ( previousdn != NULL ) {
            ber_memfree((void *)previousdn);
        }

        /* Get the optional changenumber if present. */
        if ( chgnump != NULL ) {
            if ( ber_peek_tag( ber, &len ) == LBER_INTEGER
                 && ber_get_int( ber, chgnump ) != LBER_ERROR ) {
                if ( chgnumpresentp != NULL ) {
                    *chgnumpresentp = 1;
                }
            } else {
                if ( chgnumpresentp != NULL ) {
                    *chgnumpresentp = 0;
                }
            }
        }

        ber_free( ber, 1 );
        ret = LDAP_SUCCESS;
    } else {
        ret = LDAP_CONTROL_NOT_FOUND;
    }

bail:
    ldap_set_option(ld, LDAP_OPT_RESULT_CODE, &ret);
#else
    ret = ldap_parse_entrychange_control(ld, ctrls, chgtypep, prevdnp
                                         chgnumpresentp, chgnump);
#endif

    return ret;
}

static
int
perldap_ldap_parse_sort_control(LDAP *ld, LDAPControl **ctrls,
                          ber_int_t *result, char **attribute )
{
    int ret = 0;

#ifdef USE_OPENLDAP
    LDAPControl *sort_ctrl = NULL;

    if ((sort_ctrl = ldap_control_find(LDAP_CONTROL_SORTRESPONSE, ctrls, NULL)) != NULL) {
        ret = ldap_parse_sortresponse_control(ld, sort_ctrl, result, attribute);
    } else {
        ret = LDAP_CONTROL_NOT_FOUND;
    }
#else
    ret = ldap_parse_sort_control(ld, ctrls, result, attribute);
#endif

    return ret;
}

static
int
perldap_ldap_parse_virtuallist_control(LDAP *ld, LDAPControl **ctrls,
          ber_int_t *target_posp, ber_int_t *list_sizep, int *errcodep)
{
    int ret = 0;

#ifdef USE_OPENLDAP
    LDAPControl *   vlv_ctrl = NULL;

    if ((vlv_ctrl = ldap_control_find(LDAP_CONTROL_VLVRESPONSE, ctrls, NULL)) != NULL) {
        ret = ldap_parse_vlvresponse_control(ld, vlv_ctrl, target_posp,
                                                list_sizep, NULL, errcodep);
    } else {
        ret = LDAP_CONTROL_NOT_FOUND;
    }
#else
    ret = ldap_parse_virtuallist_control(ld, ctrls, target_posp, list_sizep, errcodep);
#endif

    return ret;
}

static
void
perldap_ldap_perror(LDAP *ld, const char *s)
{
#ifdef USE_OPENLDAP
    char *  err_str = NULL;
    char *  separator;
    int     err;

    if ( s == NULL ) {
        s = separator = "";
    } else {
        separator = ": ";
    }

    ldap_get_option(ld, LDAP_OPT_RESULT_CODE, &err);
    err_str = ldap_err2string(err);
    printf("%s%s%s", s, separator, err_str);
#else
    ldap_perror(ld, s);
#endif
}

static
int
perldap_ldap_set_lderrno(LDAP *ld, int e, char *m, char *s)
{
    int ret = 0;

#ifdef USE_OPENLDAP
    ldap_set_option(ld, LDAP_OPT_RESULT_CODE, &e);
    if (m) {
        ldap_set_option(ld, LDAP_OPT_MATCHED_DN, m);
    }

    if (s) {
#ifdef LDAP_OPT_DIAGNOSTIC_MESSAGE
        ldap_set_option(ld, LDAP_OPT_DIAGNOSTIC_MESSAGE, s);
#else
        ldap_set_option(ld, LDAP_OPT_ERROR_STRING, s);
#endif
    }
#else  /* !USE_OPENLDAP */
    ret = ldap_set_lderrno(ld, e, m, s);
#endif

    return ret;
}

static
int
perldap_ldap_sort_entries(LDAP *ld, LDAPMessage **chain,
                          char *attr, LDAP_CMP_CALLBACK *cmp)
{
    int ret = 0;

#ifdef USE_OPENLDAP
    char    *attrs[2];

    attrs[0] = attr;
    attrs[1] = NULL;

    ret = perldap_ldap_multisort_entries(ld, chain, attr ? attrs : NULL, cmp);
#else
    ret = ldap_sort_entries(ld, chain, attr, cmp);
#endif

    return ret;
}

static
int
perldap_ldap_url_search(LDAP *ld, char *url, int attrsonly)
{
    int ret = 0;

#ifdef USE_OPENLDAP
    LDAPURLDesc *url_desc = NULL;
    char *old_urls = NULL;

    /* Get old URLs to preserve them. */
    ldap_get_option(ld, LDAP_OPT_URI, &old_urls);

    /* Parse the search URL. */
    ret = ldap_url_parse(url, &url_desc);
    if (ret == LDAP_SUCCESS) {
        /* Set the host/port from the URL. */
        ret = ldap_set_option(ld, LDAP_OPT_URI, url);
        if (ret == LDAP_OPT_SUCCESS) {
            ldap_search_ext(ld, url_desc->lud_dn, url_desc->lud_scope,
                    url_desc->lud_filter, url_desc->lud_attrs, attrsonly,
                    NULL, NULL, NULL, 0, &ret);
        }
    }

    /* Reset the original URLs. */
    ldap_set_option(ld, LDAP_OPT_URI, old_urls);

    /* Free parsed URL structure. */
    ldap_free_urldesc(url_desc);
#else
    ret = ldap_url_search(ld, url, attrsonly);
#endif

    return ret;
}

static
int
perldap_ldap_url_search_s(LDAP *ld, char *url, int attrsonly, LDAPMessage **res)
{
    int ret = 0;

#ifdef USE_OPENLDAP
    LDAPURLDesc *url_desc;
    char *old_urls = NULL;

    /* Get old URLs to preserve them. */
    ldap_get_option(ld, LDAP_OPT_URI, &old_urls);

    /* Parse the search URL. */
    ret = ldap_url_parse(url, &url_desc);
    if (ret == LDAP_SUCCESS) {
        /* Set the host/port from the URL. */
        ret = ldap_set_option(ld, LDAP_OPT_URI, url);
        if (ret == LDAP_OPT_SUCCESS) {
            ret = ldap_search_ext_s(ld, url_desc->lud_dn, url_desc->lud_scope,
                         url_desc->lud_filter, url_desc->lud_attrs, attrsonly,
                         NULL, NULL, NULL, 0, res);
        }
    }

    /* Reset the original URLs. */
    ldap_set_option(ld, LDAP_OPT_URI, old_urls);

    /* Free parsed URL structure. */
    ldap_free_urldesc(url_desc);
#else
    ret = ldap_url_search_s(ld, url, attrsonly, res);
#endif

    return ret;
}

static
int
perldap_ldap_url_search_st(LDAP *ld, char *url, int attrsonly,
                           struct timeval *timeout, LDAPMessage **res)
{
    int ret = 0;

#ifdef USE_OPENLDAP
    LDAPURLDesc *url_desc;
    char *old_urls = NULL;

    /* Get old URLs to preserve them. */
    ldap_get_option(ld, LDAP_OPT_URI, &old_urls);
    
    /* Parse the search URL. */
    ret = ldap_url_parse(url, &url_desc);
    if (ret == LDAP_SUCCESS) {
        /* Set the host/port from the URL. */
        ret = ldap_set_option(ld, LDAP_OPT_URI, url);
        if (ret == LDAP_OPT_SUCCESS) {
            ret = ldap_search_ext_s(ld, url_desc->lud_dn, url_desc->lud_scope,
                         url_desc->lud_filter, url_desc->lud_attrs, attrsonly,
                         NULL, NULL, timeout, 0, res);
        }
    }

    /* Reset the original URLs. */
    ldap_set_option(ld, LDAP_OPT_URI, old_urls);

    /* Free parsed URL structure. */
    ldap_free_urldesc(url_desc);
#else
    ret = ldap_url_search_st(ld, url, attrsonly, timeout, res);
#endif

    return ret;
}

static
int
perldap_ldapssl_client_init(const char *certdbpath, void *certdbhandle)
{
    int ret = 0;

#ifdef USE_OPENLDAP
    ret = ldap_set_option(NULL, LDAP_OPT_X_TLS_CACERTDIR, certdbpath);
#else
    ret = ldapssl_client_init(certdbpath, certdbhandle);
#endif

    return ret;
}

static
int
perldap_ldapssl_enable_clientauth(LDAP *ld, char *keynickname,
                                  char *keypasswd, char *certnickname)
{
    int ret = 0;

#ifdef USE_OPENLDAP
    ret = ldap_set_option(ld, LDAP_OPT_X_TLS_KEYFILE, keynickname);
    if (ret == 0) {
        ret = ldap_set_option(ld, LDAP_OPT_X_TLS_CERTFILE, certnickname);
    }
#else
    ret = ldapssl_enable_clientauth(ld, keynickname, keypasswd, certnickname);
#endif

    return ret;
}

static
LDAP *
perldap_ldapssl_init(const char *host, const char *port, int secure)
{
    LDAP *ret = NULL;

#ifdef USE_OPENLDAP
    char *ldapurl;
    int   ldapurl_len;

    if (host && port) {
        ldapurl_len = strlen(host) + strlen(port) + 11;
        ldapurl = (char *)perldap_malloc(ldapurl_len);
        snprintf(ldapurl, ldapurl_len, "ldap%s://%s:%s/",
                 (secure != 0 ? "s" : ""), host, port);
        ldap_initialize(&ret, ldapurl);
        perldap_free((void *)ldapurl);
    }
#else
    ret = ldapssl_init(host, atoi(port), secure);
#endif

    return ret;
}

#ifdef USE_OPENLDAP

static int
perldap_et_cmp( 
    const void  *aa,
    const void  *bb
)
{       
        int                     i, rc;
        struct entrything       *a = (struct entrything *)aa;
        struct entrything       *b = (struct entrything *)bb;

        if ( a->et_vals == NULL && b->et_vals == NULL )
                return( 0 );
        if ( a->et_vals == NULL )
                return( -1 );
        if ( b->et_vals == NULL )
                return( 1 );

        for ( i = 0; a->et_vals[i] && b->et_vals[i]; i++ ) {
                if ( (rc = (*perldap_et_cmp_fn)( a->et_vals[i], b->et_vals[i] ))
                    != 0 ) {
                        return( rc );
                }
        }

        if ( a->et_vals[i] == NULL && b->et_vals[i] == NULL )
                return( 0 );
        if ( a->et_vals[i] == NULL )
                return( -1 );
        return( 1 );
}

#endif


/* Return a char ** when passed a reference to an AV */
static
char **
avref2charptrptr(SV *avref)
{
   I32 avref_arraylen;
   int ix_av;
   SV **current_val;
   char **tmp_cpp;

   if ((! SvROK(avref)) ||
       (SvTYPE(SvRV(avref)) != SVt_PVAV) ||
       ((avref_arraylen = av_len((AV *)SvRV(avref))) < 0))
   {
      return NULL;
   }

   Newz(1,tmp_cpp,avref_arraylen+2,char *);
   for (ix_av = 0;ix_av <= avref_arraylen;ix_av++)
   {
      current_val = av_fetch((AV *)SvRV(avref),ix_av,0);
      tmp_cpp[ix_av] = StrDup(SvPV(*current_val,PL_na));
   }
   tmp_cpp[ix_av] = NULL;

   return (tmp_cpp);
}

/* Return a struct berval ** when passed a reference to an AV */
static
struct berval **
avref2berptrptr(SV *avref)
{
   I32 avref_arraylen;
   int ix_av,val_len;
   SV **current_val;
   char *tmp_char,*tmp2;
   struct berval **tmp_ber;

   if ((! SvROK(avref)) ||
       (SvTYPE(SvRV(avref)) != SVt_PVAV) || 
       ((avref_arraylen = av_len((AV *)SvRV(avref))) < 0))
   {
      return NULL;
   }

   Newz(1,tmp_ber,avref_arraylen+2,struct berval *);
   for (ix_av = 0;ix_av <= avref_arraylen;ix_av++)
   {
      New(1,tmp_ber[ix_av],1,struct berval);
      current_val = av_fetch((AV *)SvRV(avref),ix_av,0);

      tmp_char = SvPV(*current_val,PL_na);
      val_len = SvCUR(*current_val);

      Newz(1,tmp2,val_len+1,char);
      Copy(tmp_char,tmp2,val_len,char);

      tmp_ber[ix_av]->bv_val = tmp2;
      tmp_ber[ix_av]->bv_len = val_len;
   }
   tmp_ber[ix_av] = NULL;

   return(tmp_ber);
}

/* Return an AV reference when given a char ** */

static
SV*
charptrptr2avref(char **cppval)
{
   AV* tmp_av = newAV();
   SV* tmp_ref = newRV((SV*)tmp_av);
   int ix;

   if (cppval != NULL)
   {
      for (ix = 0; cppval[ix] != NULL; ix++)
      {
         SV* SVval = newSVpv(cppval[ix],0);
         av_push(tmp_av,SVval);
      }
      perldap_ldap_value_free(cppval);
   }
   return(tmp_ref);
}

/* Return an AV Reference when given a struct berval ** */

static
SV*
berptrptr2avref(struct berval **bval)
{
   AV* tmp_av = newAV();
   SV* tmp_ref = newRV((SV*)tmp_av);
   int ix;

   if (bval != NULL)
   {
      for(ix = 0; bval[ix] != NULL; ix++)
      {
         SV *SVval = newSVpv(bval[ix]->bv_val,bval[ix]->bv_len);
         av_push(tmp_av,SVval);
      }
      ldap_value_free_len(bval);
   }
   return(tmp_ref);
}


/* parse1mod - Take a single reference, figure out if it is a HASH, */
/*   ARRAY, or SCALAR, then extract the values and attributes and   */
/*   return a single LDAPMod pointer to this data.                  */

static
LDAPMod *
parse1mod(SV *ldap_value_ref,char *ldap_current_attribute,
          int ldap_add_func,int cont)
{
   LDAPMod *ldap_current_mod;
   static HV *ldap_current_values_hv;
   HE *ldap_change_element;
   char *ldap_current_modop;
   SV *ldap_current_value_sv;
   I32 keylen;
   int ldap_isa_ber = 0;

   if (ldap_current_attribute == NULL)
      return(NULL);
   Newz(1,ldap_current_mod,1,LDAPMod);
   ldap_current_mod->mod_type = StrDup(ldap_current_attribute);
   if (SvROK(ldap_value_ref))
   {
     if (SvTYPE(SvRV(ldap_value_ref)) == SVt_PVHV)
     {
      if (!cont)
      {
         ldap_current_values_hv = (HV *) SvRV(ldap_value_ref);
         hv_iterinit(ldap_current_values_hv);
      }
      if ((ldap_change_element = hv_iternext(ldap_current_values_hv)) == NULL)
         return(NULL);
      ldap_current_modop = hv_iterkey(ldap_change_element,&keylen);
      ldap_current_value_sv = hv_iterval(ldap_current_values_hv,
        ldap_change_element);
      if (ldap_add_func == 1)
      {
         ldap_current_mod->mod_op = 0;
      } else {
         if (strchr(ldap_current_modop,'a') != NULL)
         {
            ldap_current_mod->mod_op = LDAP_MOD_ADD;
         } else if (strchr(ldap_current_modop,'r') != NULL)
         {
            ldap_current_mod->mod_op = LDAP_MOD_REPLACE;
         } else if (strchr(ldap_current_modop,'d') != NULL) {
            ldap_current_mod->mod_op = LDAP_MOD_DELETE;
         } else {
            return(NULL);
         }
      }
      if (strchr(ldap_current_modop,'b') != NULL)
      {
         ldap_isa_ber = 1;
         ldap_current_mod->mod_op = ldap_current_mod->mod_op | LDAP_MOD_BVALUES;
      }
      if (SvTYPE(SvRV(ldap_current_value_sv)) == SVt_PVAV)
      {
         if (ldap_isa_ber == 1)
         {
            ldap_current_mod->mod_bvalues =
		avref2berptrptr(ldap_current_value_sv);
         } else {
            ldap_current_mod->mod_values =
		avref2charptrptr(ldap_current_value_sv);
         }
      }
     } else if (SvTYPE(SvRV(ldap_value_ref)) == SVt_PVAV) {
      if (cont)
         return NULL;
      if (ldap_add_func == 1)
         ldap_current_mod->mod_op = 0;
      else
         ldap_current_mod->mod_op = LDAP_MOD_REPLACE;
      ldap_current_mod->mod_values = avref2charptrptr(ldap_value_ref);
      if (ldap_current_mod->mod_values == NULL)
      {
         ldap_current_mod->mod_op = LDAP_MOD_DELETE;
      }
     }
   } else {
      if (cont)
         return NULL;
      if (strcmp(SvPV(ldap_value_ref,PL_na),"") == 0)
      {
         if (ldap_add_func != 1)
         {
            ldap_current_mod->mod_op = LDAP_MOD_DELETE;
            ldap_current_mod->mod_values = NULL;
         } else {
            return(NULL);
         }
      } else {
         if (ldap_add_func == 1)
         {
            ldap_current_mod->mod_op = 0;
         } else {
            ldap_current_mod->mod_op = LDAP_MOD_REPLACE;
         }
         New(1,ldap_current_mod->mod_values,2,char *);
         ldap_current_mod->mod_values[0] = StrDup(SvPV(ldap_value_ref,PL_na));
         ldap_current_mod->mod_values[1] = NULL;
      }
   }
   return(ldap_current_mod);
}

/* calc_mod_size                                                           */
/* Calculates the number of LDAPMod's buried inside the ldap_change passed */
/* in.  This is used by hash2mod to calculate the size to allocate in Newz */
static
int
calc_mod_size(HV *ldap_change)
{
   int mod_size = 0;
   HE *ldap_change_element;
   SV *ldap_change_element_value_ref;
   HV *ldap_change_element_value;

   hv_iterinit(ldap_change);

   while((ldap_change_element = hv_iternext(ldap_change)) != NULL)
   {
      ldap_change_element_value_ref = hv_iterval(ldap_change,ldap_change_element);
      /* Hashes can take up multiple mod slots. */
      if ( (SvROK(ldap_change_element_value_ref)) &&
           (SvTYPE(SvRV(ldap_change_element_value_ref)) == SVt_PVHV) )
      {
         ldap_change_element_value = (HV *)SvRV(ldap_change_element_value_ref);
         hv_iterinit(ldap_change_element_value);
         while ( hv_iternext(ldap_change_element_value) != NULL )
         {
            mod_size++;
         }
      }
      /* scalars and array references only take up one mod slot */
      else
      {
         mod_size++;
      }
   }

   return(mod_size);
}


/* hash2mod - Cycle through all the keys in the hash and properly call */
/*    the appropriate functions to build a NULL terminated list of     */
/*    LDAPMod pointers.                                                */

static
LDAPMod **
hash2mod(SV *ldap_change_ref,int ldap_add_func,const char *func)
{
   LDAPMod **ldapmod = NULL;
   LDAPMod *ldap_current_mod;
   int ldap_attribute_count = 0;
   HE *ldap_change_element;
   char *ldap_current_attribute;
   SV *ldap_current_value_sv;
   I32 keylen;
   HV *ldap_change;

   if (!SvROK(ldap_change_ref) || SvTYPE(SvRV(ldap_change_ref)) != SVt_PVHV)
      croak("Mozilla::LDAP::API::%s needs Hash reference as argument 3.",func);

   ldap_change = (HV *)SvRV(ldap_change_ref);

   Newz(1,ldapmod,1+calc_mod_size(ldap_change),LDAPMod *);
   hv_iterinit(ldap_change);
   while((ldap_change_element = hv_iternext(ldap_change)) != NULL)
   {
      ldap_current_attribute = hv_iterkey(ldap_change_element,&keylen);
      ldap_current_value_sv = hv_iterval(ldap_change,ldap_change_element);
      ldap_current_mod = parse1mod(ldap_current_value_sv,
        ldap_current_attribute,ldap_add_func,0);
      while (ldap_current_mod != NULL)
      {
         ldap_attribute_count++;
         ldapmod[ldap_attribute_count-1] = (LDAPMod *)ldap_current_mod;
         ldap_current_mod = parse1mod(ldap_current_value_sv,
           ldap_current_attribute,ldap_add_func,1);

      }
   }
   ldapmod[ldap_attribute_count] = NULL;
   return ldapmod;
}

/* StrCaseCmp - Replacement for strcasecmp, since it doesn't exist on many
   systems, including NT...  */

static
int
StrCaseCmp(const char *s, const char *t)
{
   while (*s && *t && toupper(*s) == toupper(*t))
   {
      s++; t++;
   }
   return(toupper(*s) - toupper(*t));
}

/*
 * StrDup
 *
 * Duplicates a string, but uses the Perl memory allocation
 * routines (so it can be free by the internal routines
 */
static
char *
StrDup(const char *source)
{
   char *dest;
   STRLEN length;

   if ( source == NULL )
      return(NULL);
   length = strlen(source);
   Newz(1,dest,length+1,char);
   Copy(source,dest,length+1,char);

   return(dest);
}

/* internal_rebind_proc - Wrapper to call a PERL rebind process.  We
 * need separate rebind callbacks for MozLDAP and OpenLDAP. */
#ifdef USE_OPENLDAP
static
int
LDAP_CALL
internal_rebind_proc(LDAP *ld, LDAP_CONST char *url,
                     ber_tag_t request, ber_int_t msgid, void *arg)
{
    int ret;
    struct berval         cred;
    int count = 0;
    int authmethod;
    char *pwd;
    char *dn;
    dSP;

    ENTER ;
    SAVETMPS ;
    count = perl_call_sv(ldap_perl_rebindproc,G_ARRAY|G_NOARGS);

    SPAGAIN;

    if (count != 3)
       croak("ldap_perl_rebindproc: Expected DN, PASSWORD, and AUTHTYPE returned.\n");

    authmethod = POPi;
    pwd = StrDup(POPp);
    dn = StrDup(POPp);

    FREETMPS ;
    LEAVE ;

    cred.bv_val = pwd;
    cred.bv_len = strlen(pwd);

    ret = ldap_sasl_bind_s(ld, dn, LDAP_SASL_SIMPLE,
                          &cred, NULL, NULL, NULL);

    if (dn)
    {
       Safefree(dn);
    }
    if (pwd)
    {
       Safefree(pwd);
    }

    return ret;
}

/* NT and internal_rebind_proc hate each other, so they need this... */
static
int
LDAP_CALL
ldap_default_rebind_proc(LDAP *ld, LDAP_CONST char *url,
                         ber_tag_t request, ber_int_t msgid, void *arg)
{
    int ret = 0;
    struct berval cred;

    if (!ldap_default_rebind_dn || !ldap_default_rebind_pwd)
    {
        return LDAP_OPERATIONS_ERROR;
    }

    cred.bv_val = ldap_default_rebind_pwd;
    cred.bv_len = strlen(ldap_default_rebind_pwd);

    ret = ldap_sasl_bind_s(ld, ldap_default_rebind_dn, LDAP_SASL_SIMPLE,
                              &cred, NULL, NULL, NULL);

   return ret;
}
#else  /* !USE_OPENLDAP */ 
static
int
LDAP_CALL
internal_rebind_proc(LDAP *ld, char **dnp, char **pwp,
                     int *authmethodp, int freeit, void *arg)
{
   if (freeit == 0)
   {
      int count = 0;
      dSP;

      ENTER ;
      SAVETMPS ;
      count = perl_call_sv(ldap_perl_rebindproc,G_ARRAY|G_NOARGS);

      SPAGAIN;

      if (count != 3)
         croak("ldap_perl_rebindproc: Expected DN, PASSWORD, and AUTHTYPE returned.\n");

      *authmethodp = POPi;
      *pwp = StrDup(POPp);
      *dnp = StrDup(POPp);

      PUTBACK ;
      FREETMPS ;
      LEAVE ;
   } else {
      if (dnp && *dnp)
      {
         Safefree(*dnp);
      }
      if (pwp && *pwp)
      {
         Safefree(*pwp);
      }
   }
   return(LDAP_SUCCESS);
}

/* NT and internal_rebind_proc hate each other, so they need this... */
static
int
LDAP_CALL
ldap_default_rebind_proc(LDAP *ld, char **dn, char **pwd,
                         int *auth, int freeit, void *arg)
{
  if (!ldap_default_rebind_dn || !ldap_default_rebind_pwd)
    {
      *dn = NULL;
      *pwd = NULL;
      *auth = 0;

      return LDAP_OPERATIONS_ERROR;
    }

  *dn = ldap_default_rebind_dn;
  *pwd = ldap_default_rebind_pwd;
  *auth = ldap_default_rebind_auth;

  return LDAP_SUCCESS;
}
#endif

/* internal_sortcmp_proc - Wrapper to call a PERL cmp function */
static
int
internal_sortcmp_proc(const char *s1, const char *s2)
{
  int count;
  int res;

  dSP;
  ENTER;
  SAVETMPS;

  PUSHMARK(SP);
  XPUSHs(sv_2mortal(newSVpv(s1, 0)));
  XPUSHs(sv_2mortal(newSVpv(s2, 0)));
  PUTBACK;

  count = perl_call_sv(ldap_perl_sortcmp, G_SCALAR);
  SPAGAIN;

  if (count != 1)
     croak("ldap_perl_sortcmp: Expected an INT to be returned.\n");

  res = POPi;

  PUTBACK;
  FREETMPS;
  LEAVE;

  return res;
}


#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif


XS_EUPXS(XS_Mozilla__LDAP__API_constant); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_constant)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "name, arg");
    {
	char *	name = (char *)SvPV_nolen(ST(0))
;
	int	arg = (int)SvIV(ST(1))
;
	double	RETVAL;
	dXSTARG;

	RETVAL = constant(name, arg);
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_abandon); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_abandon)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ld, msgid");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	int	msgid = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;
	RETVAL = ldap_abandon_ext(ld, msgid, NULL, NULL);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_abandon_ext); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_abandon_ext)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "ld, msgid, serverctrls, clientctrls");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	int	msgid = (int)SvIV(ST(1))
;
	LDAPControl **	serverctrls = INT2PTR(LDAPControl **,SvIV(ST(2)))
;
	LDAPControl **	clientctrls = INT2PTR(LDAPControl **,SvIV(ST(3)))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = ldap_abandon_ext(ld, msgid, serverctrls, clientctrls);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_add)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ld, dn, attrs");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	const char *	dn = (const char *)SvPV_nolen(ST(1))
;
	LDAPMod **	attrs = hash2mod(ST(2),1,"ldap_add");
	int	RETVAL;
	dXSTARG;
	ldap_add_ext(ld, dn, attrs, NULL, NULL, &RETVAL);
	XSprePUSH; PUSHi((IV)RETVAL);
	if (attrs)
	  ldap_mods_free(attrs, 1);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_add_ext); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_add_ext)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "ld, dn, attrs, serverctrls, clientctrls, msgidp");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	const char *	dn = (const char *)SvPV_nolen(ST(1))
;
	LDAPMod **	attrs = hash2mod(ST(2),1,"ldap_add_ext");
	LDAPControl **	serverctrls = INT2PTR(LDAPControl **,SvIV(ST(3)))
;
	LDAPControl **	clientctrls = INT2PTR(LDAPControl **,SvIV(ST(4)))
;
	int	msgidp;
	int	RETVAL;
	dXSTARG;

	RETVAL = ldap_add_ext(ld, dn, attrs, serverctrls, clientctrls, &msgidp);
	sv_setiv(ST(5), (IV)msgidp);
	SvSETMAGIC(ST(5));
	XSprePUSH; PUSHi((IV)RETVAL);
	if (attrs)
	  ldap_mods_free(attrs, 1);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_add_ext_s); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_add_ext_s)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "ld, dn, attrs, serverctrls, clientctrls");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	const char *	dn = (const char *)SvPV_nolen(ST(1))
;
	LDAPMod **	attrs = hash2mod(ST(2),1,"ldap_add_ext_s");
	LDAPControl **	serverctrls = INT2PTR(LDAPControl **,SvIV(ST(3)))
;
	LDAPControl **	clientctrls = INT2PTR(LDAPControl **,SvIV(ST(4)))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = ldap_add_ext_s(ld, dn, attrs, serverctrls, clientctrls);
	XSprePUSH; PUSHi((IV)RETVAL);
	if (attrs)
	  ldap_mods_free(attrs, 1);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_add_s); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_add_s)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ld, dn, attrs");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	const char *	dn = (const char *)SvPV_nolen(ST(1))
;
	LDAPMod **	attrs = hash2mod(ST(2),1,"ldap_add_s");
	int	RETVAL;
	dXSTARG;
	RETVAL = ldap_add_ext_s(ld, dn, attrs, NULL, NULL);
	XSprePUSH; PUSHi((IV)RETVAL);
	if (attrs)
	  ldap_mods_free(attrs, 1);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_ber_free); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_ber_free)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ber, freebuf");
    {
	BerElement *	ber = INT2PTR(BerElement *,SvIV(ST(0)))
;
	int	freebuf = (int)SvIV(ST(1))
;
	{
	   if (ber)
	   {
	      ber_free(ber, freebuf);
	   }
	}
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_bind); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_bind)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "ld, dn, passwd, authmethod");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	const char *	dn = (const char *)SvPV_nolen(ST(1))
;
	char *	passwd = (char *)SvPV_nolen(ST(2))
;
	struct berval	cred;
	int	RETVAL;
	dXSTARG;
	cred.bv_val = passwd;
	cred.bv_len = ( passwd == NULL ) ? 0 : strlen( passwd );
	ldap_sasl_bind(ld, dn, LDAP_SASL_SIMPLE,
	               &cred, NULL, NULL, &RETVAL);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_bind_s); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_bind_s)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "ld, dn, passwd, authmethod");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	const char *	dn = (const char *)SvPV_nolen(ST(1))
;
	char *	passwd = (char *)SvPV_nolen(ST(2))
;
	struct berval	cred;
	int	RETVAL;
	dXSTARG;
	cred.bv_val = passwd;
	cred.bv_len = ( passwd == NULL ) ? 0 : strlen( passwd );
	RETVAL = ldap_sasl_bind_s(ld, dn, LDAP_SASL_SIMPLE,
	                          &cred, NULL, NULL, NULL);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_compare); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_compare)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "ld, dn, attr, value");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	const char *	dn = (const char *)SvPV_nolen(ST(1))
;
	const char *	attr = (const char *)SvPV_nolen(ST(2))
;
	char *	value = (char *)SvPV_nolen(ST(3))
;
	struct berval	bvalue;
	int	RETVAL;
	dXSTARG;
	bvalue.bv_val = value;
	bvalue.bv_len = ( value == NULL ) ? 0 : strlen( value );
	ldap_compare_ext(ld, dn, attr, &bvalue, NULL, NULL, &RETVAL);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_compare_ext); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_compare_ext)
{
    dVAR; dXSARGS;
    if (items != 7)
       croak_xs_usage(cv,  "ld, dn, attr, bvalue, serverctrls, clientctrls, msgidp");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	const char *	dn = (const char *)SvPV_nolen(ST(1))
;
	const char *	attr = (const char *)SvPV_nolen(ST(2))
;
	struct berval	bvalue;
	LDAPControl **	serverctrls = INT2PTR(LDAPControl **,SvIV(ST(4)))
;
	LDAPControl **	clientctrls = INT2PTR(LDAPControl **,SvIV(ST(5)))
;
	int	msgidp;
	int	RETVAL;
	dXSTARG;

	bvalue.bv_val = (char *)SvPV(ST(3),PL_na);
	bvalue.bv_len = PL_na
;

	RETVAL = ldap_compare_ext(ld, dn, attr, &bvalue, serverctrls, clientctrls, &msgidp);
	sv_setiv(ST(6), (IV)msgidp);
	SvSETMAGIC(ST(6));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_compare_ext_s); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_compare_ext_s)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "ld, dn, attr, bvalue, serverctrls, clientctrls");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	const char *	dn = (const char *)SvPV_nolen(ST(1))
;
	const char *	attr = (const char *)SvPV_nolen(ST(2))
;
	struct berval	bvalue;
	LDAPControl **	serverctrls = INT2PTR(LDAPControl **,SvIV(ST(4)))
;
	LDAPControl **	clientctrls = INT2PTR(LDAPControl **,SvIV(ST(5)))
;
	int	RETVAL;
	dXSTARG;

	bvalue.bv_val = (char *)SvPV(ST(3),PL_na);
	bvalue.bv_len = PL_na
;

	RETVAL = ldap_compare_ext_s(ld, dn, attr, &bvalue, serverctrls, clientctrls);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_compare_s); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_compare_s)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "ld, dn, attr, value");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	const char *	dn = (const char *)SvPV_nolen(ST(1))
;
	const char *	attr = (const char *)SvPV_nolen(ST(2))
;
	char *	value = (char *)SvPV_nolen(ST(3))
;
	struct berval   bvalue;
	int	RETVAL;
	dXSTARG;
	bvalue.bv_val = value;
	bvalue.bv_len = ( value == NULL ) ? 0 : strlen( value );
	RETVAL = ldap_compare_ext_s(ld, dn, attr, &bvalue, NULL, NULL);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_control_free); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_control_free)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ctrl");
    {
	LDAPControl *	ctrl = INT2PTR(LDAPControl *,SvIV(ST(0)))
;

	ldap_control_free(ctrl);
    }
    XSRETURN_EMPTY;
}

#ifdef CONTROLS_COUNT_WORKS
#define XSubPPtmpAAAA 1


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_controls_count); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_controls_count)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ctrls");
    {
	LDAPControl **	ctrls = INT2PTR(LDAPControl **,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = ldap_controls_count(ctrls);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#endif

XS_EUPXS(XS_Mozilla__LDAP__API_ldap_controls_free); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_controls_free)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ctrls");
    {
	LDAPControl **	ctrls = INT2PTR(LDAPControl **,SvIV(ST(0)))
;

	ldap_controls_free(ctrls);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_count_entries); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_count_entries)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ld, result");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAPMessage *	result = INT2PTR(LDAPMessage *,SvIV(ST(1)))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = ldap_count_entries(ld, result);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_count_messages); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_count_messages)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ld, result");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAPMessage *	result = INT2PTR(LDAPMessage *,SvIV(ST(1)))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = ldap_count_messages(ld, result);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_count_references); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_count_references)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ld, result");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAPMessage *	result = INT2PTR(LDAPMessage *,SvIV(ST(1)))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = ldap_count_references(ld, result);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_create_filter); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_create_filter)
{
    dVAR; dXSARGS;
    if (items != 8)
       croak_xs_usage(cv,  "buf, buflen, pattern, prefix, suffix, attr, value, valwords");
    {
	char *	buf = (char *)SvPV_nolen(ST(0))
;
	unsigned long	buflen = (unsigned long)SvUV(ST(1))
;
	char *	pattern = (char *)SvPV_nolen(ST(2))
;
	char *	prefix = (char *)SvPV_nolen(ST(3))
;
	char *	suffix = (char *)SvPV_nolen(ST(4))
;
	char *	attr = (char *)SvPV_nolen(ST(5))
;
	char *	value = (char *)SvPV_nolen(ST(6))
;
	char **        valwords = (char **)avref2charptrptr(ST(7))
;
	int	RETVAL;
	dXSTARG;
	/* This is a not implemented when using OpenLDAP. */
#ifdef USE_OPENLDAP
	RETVAL = LDAP_NOT_SUPPORTED;
#else
	RETVAL = ldap_create_filter(buf, buflen, pattern, prefix,
	                            suffix, attr, value, valwords);
#endif
	sv_setpv((SV*)ST(0), buf);
	SvSETMAGIC(ST(0));
	XSprePUSH; PUSHi((IV)RETVAL);
	if (valwords)
	  perldap_ldap_value_free(valwords);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_create_persistentsearch_control); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_create_persistentsearch_control)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "ld, changetypes, changesonly, return_echg_ctrls, ctrl_iscritical, ctrlp");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	int	changetypes = (int)SvIV(ST(1))
;
	int	changesonly = (int)SvIV(ST(2))
;
	int	return_echg_ctrls = (int)SvIV(ST(3))
;
	char	ctrl_iscritical = (char)*SvPV_nolen(ST(4))
;
	LDAPControl **	ctrlp;
	int	RETVAL;
	dXSTARG;
	RETVAL = perldap_ldap_create_persistentsearch_control(ld, changetypes, changesonly,
	                                         return_echg_ctrls, ctrl_iscritical, ctrlp);
	sv_setiv(ST(5), PTR2IV(ctrlp));
	SvSETMAGIC(ST(5));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_create_sort_control); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_create_sort_control)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "ld, sortKeyList, ctrl_iscritical, ctrlp");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAPsortkey **	sortKeyList = INT2PTR(LDAPsortkey **,SvIV(ST(1)))
;
	char	ctrl_iscritical = (char)*SvPV_nolen(ST(2))
;
	LDAPControl **	ctrlp;
	int	RETVAL;
	dXSTARG;
	RETVAL = perldap_ldap_create_sort_control(ld, sortKeyList, ctrl_iscritical, ctrlp);
	sv_setiv(ST(3), PTR2IV(ctrlp));
	SvSETMAGIC(ST(3));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_create_sort_keylist); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_create_sort_keylist)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "sortKeyList, string_rep");
    {
	LDAPsortkey **	sortKeyList;
	char *	string_rep = (char *)SvPV_nolen(ST(1))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = ldap_create_sort_keylist(&sortKeyList, string_rep);
	sv_setiv(ST(0), PTR2IV(sortKeyList));
	SvSETMAGIC(ST(0));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_create_virtuallist_control); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_create_virtuallist_control)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ld, ldvlistp, ctrlp");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAPVirtualList *	ldvlistp = INT2PTR(LDAPVirtualList *,SvIV(ST(1)))
;
	LDAPControl **	ctrlp;
	int	RETVAL;
	dXSTARG;
	RETVAL = perldap_ldap_create_virtuallist_control(ld, ldvlistp, ctrlp);
	sv_setiv(ST(2), PTR2IV(ctrlp));
	SvSETMAGIC(ST(2));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_delete); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_delete)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ld, dn");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	const char *	dn = (const char *)SvPV_nolen(ST(1))
;
	int	RETVAL;
	dXSTARG;
	ldap_delete_ext(ld, dn, NULL, NULL, &RETVAL);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_delete_ext); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_delete_ext)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "ld, dn, serverctrls, clientctrls, msgidp");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	const char *	dn = (const char *)SvPV_nolen(ST(1))
;
	LDAPControl **	serverctrls = INT2PTR(LDAPControl **,SvIV(ST(2)))
;
	LDAPControl **	clientctrls = INT2PTR(LDAPControl **,SvIV(ST(3)))
;
	int	msgidp;
	int	RETVAL;
	dXSTARG;

	RETVAL = ldap_delete_ext(ld, dn, serverctrls, clientctrls, &msgidp);
	sv_setiv(ST(4), (IV)msgidp);
	SvSETMAGIC(ST(4));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_delete_ext_s); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_delete_ext_s)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "ld, dn, serverctrls, clientctrls");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	const char *	dn = (const char *)SvPV_nolen(ST(1))
;
	LDAPControl **	serverctrls = INT2PTR(LDAPControl **,SvIV(ST(2)))
;
	LDAPControl **	clientctrls = INT2PTR(LDAPControl **,SvIV(ST(3)))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = ldap_delete_ext_s(ld, dn, serverctrls, clientctrls);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_delete_s); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_delete_s)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ld, dn");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	const char *	dn = (const char *)SvPV_nolen(ST(1))
;
	int	RETVAL;
	dXSTARG;
	RETVAL = ldap_delete_ext_s(ld, dn, NULL, NULL);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_dn2ufn); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_dn2ufn)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dn");
    {
	const char *	dn = (const char *)SvPV_nolen(ST(0))
;
	char *	RETVAL;
	dXSTARG;

	RETVAL = ldap_dn2ufn(dn);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_err2string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_err2string)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "err");
    {
	int	err = (int)SvIV(ST(0))
;
	char *	RETVAL;
	dXSTARG;

	RETVAL = ldap_err2string(err);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_explode_dn); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_explode_dn)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "dn, notypes");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	const char *	dn = (const char *)SvPV_nolen(ST(0))
;
	const int	notypes = (const int)SvIV(ST(1))
;
	{
	   char **MOZLDAP_VAL = ldap_explode_dn(dn,notypes);
	   RET_CPP(MOZLDAP_VAL);
	}
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_explode_rdn); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_explode_rdn)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "dn, notypes");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	const char *	dn = (const char *)SvPV_nolen(ST(0))
;
	int	notypes = (int)SvIV(ST(1))
;
	{
	   char **MOZLDAP_VAL = ldap_explode_rdn(dn,notypes);
	   RET_CPP(MOZLDAP_VAL);
	}
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_extended_operation); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_extended_operation)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "ld, requestoid, requestdata, serverctrls, clientctrls, msgidp");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	const char *	requestoid = (const char *)SvPV_nolen(ST(1))
;
	struct berval	requestdata;
	LDAPControl **	serverctrls = INT2PTR(LDAPControl **,SvIV(ST(3)))
;
	LDAPControl **	clientctrls = INT2PTR(LDAPControl **,SvIV(ST(4)))
;
	int	msgidp;
	int	RETVAL;
	dXSTARG;

	requestdata.bv_val = (char *)SvPV(ST(2),PL_na);
	requestdata.bv_len = PL_na
;

	RETVAL = ldap_extended_operation(ld, requestoid, &requestdata, serverctrls, clientctrls, &msgidp);
	sv_setiv(ST(5), (IV)msgidp);
	SvSETMAGIC(ST(5));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_extended_operation_s); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_extended_operation_s)
{
    dVAR; dXSARGS;
    if (items != 7)
       croak_xs_usage(cv,  "ld, requestoid, requestdata, serverctrls, clientctrls, retoidp, retdatap");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	const char *	requestoid = (const char *)SvPV_nolen(ST(1))
;
	struct berval	requestdata;
	LDAPControl **	serverctrls = INT2PTR(LDAPControl **,SvIV(ST(3)))
;
	LDAPControl **	clientctrls = INT2PTR(LDAPControl **,SvIV(ST(4)))
;
	char *	retoidp;
	struct berval *	retdatap;
	int	RETVAL;
	dXSTARG;

	requestdata.bv_val = (char *)SvPV(ST(2),PL_na);
	requestdata.bv_len = PL_na
;

	RETVAL = ldap_extended_operation_s(ld, requestoid, &requestdata, serverctrls, clientctrls, &retoidp, &retdatap);
	sv_setpv((SV*)ST(5), retoidp);
	SvSETMAGIC(ST(5));
    if (retdatap) {
        sv_setpvn(ST(6),retdatap->bv_val,retdatap->bv_len);
        ber_bvfree(retdatap);
    }
	SvSETMAGIC(ST(6));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_first_attribute); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_first_attribute)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ld, entry, ber");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAPMessage *	entry = INT2PTR(LDAPMessage *,SvIV(ST(1)))
;
	BerElement *	ber;
	char *	RETVAL;
	dXSTARG;

	RETVAL = ldap_first_attribute(ld, entry, &ber);
	sv_setiv(ST(2), PTR2IV(ber));
	SvSETMAGIC(ST(2));
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
	ldap_memfree(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_first_entry); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_first_entry)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ld, chain");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAPMessage *	chain = INT2PTR(LDAPMessage *,SvIV(ST(1)))
;
	LDAPMessage *	RETVAL;
	dXSTARG;

	RETVAL = ldap_first_entry(ld, chain);
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_first_message); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_first_message)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ld, res");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAPMessage *	res = INT2PTR(LDAPMessage *,SvIV(ST(1)))
;
	LDAPMessage *	RETVAL;
	dXSTARG;

	RETVAL = ldap_first_message(ld, res);
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_first_reference); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_first_reference)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ld, res");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAPMessage *	res = INT2PTR(LDAPMessage *,SvIV(ST(1)))
;
	LDAPMessage *	RETVAL;
	dXSTARG;

	RETVAL = ldap_first_reference(ld, res);
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_free_friendlymap); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_free_friendlymap)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "map");
    {
	FriendlyMap *	map = INT2PTR(FriendlyMap *,SvIV(ST(0)))
;
	/* This is a no-op when using OpenLDAP. */
#ifndef USE_OPENLDAP
	ldap_free_friendlymap(map);
#endif
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_free_sort_keylist); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_free_sort_keylist)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sortKeyList");
    {
	LDAPsortkey **	sortKeyList = INT2PTR(LDAPsortkey **,SvIV(ST(0)))
;

	ldap_free_sort_keylist(sortKeyList);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_free_urldesc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_free_urldesc)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ludp");
    {
	LDAPURLDesc *	ludp = INT2PTR(LDAPURLDesc *,SvIV(ST(0)))
;

	ldap_free_urldesc(ludp);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_friendly_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_friendly_name)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "filename, name, map");
    {
	char *	filename = (char *)SvPV_nolen(ST(0))
;
	char *	name = (char *)SvPV_nolen(ST(1))
;
	FriendlyMap *	map = INT2PTR(FriendlyMap *,SvIV(ST(2)))
;
	char *	RETVAL;
	dXSTARG;
	/* This is not implemented when using OpenLDAP.  We just return
	 * the original "un-friendly" name as MozLDAP does when there is
	 * an error. */
#ifdef USE_OPENLDAP
	RETVAL = name;
#else
	RETVAL = ldap_friendly_name(filename, name, map);
#endif
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_get_dn); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_get_dn)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ld, entry");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAPMessage *	entry = INT2PTR(LDAPMessage *,SvIV(ST(1)))
;
	char *	RETVAL;
	dXSTARG;

	RETVAL = ldap_get_dn(ld, entry);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
	ldap_memfree(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_get_entry_controls); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_get_entry_controls)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ld, entry, serverctrlsp");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAPMessage *	entry = INT2PTR(LDAPMessage *,SvIV(ST(1)))
;
	LDAPControl **	serverctrlsp;
	int	RETVAL;
	dXSTARG;

	RETVAL = ldap_get_entry_controls(ld, entry, &serverctrlsp);
	sv_setiv(ST(2), PTR2IV(serverctrlsp));
	SvSETMAGIC(ST(2));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_getfilter_free); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_getfilter_free)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "lfdp");
    {
	LDAPFiltDesc *	lfdp = INT2PTR(LDAPFiltDesc *,SvIV(ST(0)))
;
	/* This is a no-op when using OpenLDAP. */
#ifndef USE_OPENLDAP
	ldap_getfilter_free(lfdp);
#endif
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_getfirstfilter); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_getfirstfilter)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "lfdp, tagpat, value");
    {
	LDAPFiltDesc *	lfdp = INT2PTR(LDAPFiltDesc *,SvIV(ST(0)))
;
	char *	tagpat = (char *)SvPV_nolen(ST(1))
;
	char *	value = (char *)SvPV_nolen(ST(2))
;
	LDAPFiltInfo *	RETVAL;
	dXSTARG;
	/* This is not implemented when using OpenLDAP. */
#ifdef USE_OPENLDAP
	RETVAL = NULL;
#else
	RETVAL = ldap_getfirstfilter(lfdp, tagpat, value);
#endif
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_get_lang_values); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_get_lang_values)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "ld, entry, target, type");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAPMessage *	entry = INT2PTR(LDAPMessage *,SvIV(ST(1)))
;
	const char *	target = (const char *)SvPV_nolen(ST(2))
;
	char *	type = (char *)SvPV_nolen(ST(3))
;
	{
	/* This is not implemented when using OpenLDAP. */
#ifdef USE_OPENLDAP
	   int ret = LDAP_NOT_SUPPORTED;
	   char ** MOZLDAP_VAL = NULL;

	   ldap_set_option(ld, LDAP_OPT_RESULT_CODE, &ret);
#else
	   char ** MOZLDAP_VAL = ldap_get_lang_values(ld,entry,target,&type);
#endif
	   RET_CPP(MOZLDAP_VAL);
	}
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_get_lang_values_len); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_get_lang_values_len)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "ld, entry, target, type");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAPMessage *	entry = INT2PTR(LDAPMessage *,SvIV(ST(1)))
;
	const char *	target = (const char *)SvPV_nolen(ST(2))
;
	char *	type = (char *)SvPV_nolen(ST(3))
;
	{
	/* This is not implemented when using OpenLDAP. */
#ifdef USE_OPENLDAP
	   int ret = LDAP_NOT_SUPPORTED;
	   struct berval ** MOZLDAP_VAL = NULL;

	   ldap_set_option(ld, LDAP_OPT_RESULT_CODE, &ret);
#else
	   struct berval ** MOZLDAP_VAL = 
	       ldap_get_lang_values_len(ld,entry,target,&type);
#endif
	   RET_BVPP(MOZLDAP_VAL);
	}
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_get_lderrno); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_get_lderrno)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "ld, ...");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
	{
	   char *match = (char *)NULL, *msg = (char *)NULL;
           SV *tmp, *m = (SV *)NULL, *s = (SV *)NULL;

	   if (items > 1)
	   {
	      m = ST(1);
	      if (items > 2)
	         s = ST(2);
           }
#ifdef USE_OPENLDAP
	   ldap_get_option(ld, LDAP_OPT_RESULT_CODE, &RETVAL);
	   if (m && SvROK(m)) {
	      ldap_get_option(ld, LDAP_OPT_MATCHED_DN, &match);
	   }
	   if (s && SvROK(s)) {
#ifdef LDAP_OPT_DIAGNOSTIC_MESSAGE
	      ldap_get_option(ld, LDAP_OPT_DIAGNOSTIC_MESSAGE, &msg);
#else
	      ldap_get_option(ld, LDAP_OPT_ERROR_STRING, &msg);
#endif
	   }
#else  /* !USE_OPENLDAP */
	   RETVAL = ldap_get_lderrno(ld, (m && SvROK(m)) ? &match : (char **)NULL,
	                                 (s && SvROK(s)) ? &msg : (char **)NULL);
#endif

	   if (match)
	   {
	      tmp = SvRV(m);
	      if (SvTYPE(tmp) <= SVt_PV)
	         sv_setpv(tmp, match);
	   }
	   if (msg)
	   {
	      tmp = SvRV(s);
	      if (SvTYPE(tmp) <= SVt_PV)
	         sv_setpv(tmp, msg);
	   }

	}
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_getnextfilter); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_getnextfilter)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "lfdp");
    {
	LDAPFiltDesc *	lfdp = INT2PTR(LDAPFiltDesc *,SvIV(ST(0)))
;
	LDAPFiltInfo *	RETVAL;
	dXSTARG;
	/* This is not implemented when using OpenLDAP. */
#ifdef USE_OPENLDAP
	RETVAL = NULL;
#else
	RETVAL = ldap_getnextfilter(lfdp);
#endif
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_get_option); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_get_option)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ld, option, optdata");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	int	option = (int)SvIV(ST(1))
;
	int	optdata;
	int	RETVAL;
	dXSTARG;

	RETVAL = ldap_get_option(ld, option, &optdata);
	sv_setiv(ST(2), (IV)optdata);
	SvSETMAGIC(ST(2));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_get_values); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_get_values)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ld, entry, target");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAPMessage *	entry = INT2PTR(LDAPMessage *,SvIV(ST(1)))
;
	const char *	target = (const char *)SvPV_nolen(ST(2))
;
	{
	/* This is not implemented when using OpenLDAP. */
#ifdef USE_OPENLDAP
	   int ret = LDAP_NOT_SUPPORTED;
	   char **MOZLDAP_VAL = NULL;

	   ldap_set_option(ld, LDAP_OPT_RESULT_CODE, &ret);
#else
	   char **MOZLDAP_VAL = ldap_get_values(ld,entry,target);
#endif
	   RET_CPP(MOZLDAP_VAL);
	}
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_get_values_len); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_get_values_len)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ld, entry, target");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAPMessage *	entry = INT2PTR(LDAPMessage *,SvIV(ST(1)))
;
	const char *	target = (const char *)SvPV_nolen(ST(2))
;
	{
	   struct berval **MOZLDAP_VAL = ldap_get_values_len(ld,entry,target);
	   RET_BVPP(MOZLDAP_VAL);
	}
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_init); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_init)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "host, port");
    {
	const char *	host = (const char *)SvPV_nolen(ST(0))
;
	const char *	port = (const char *)SvPV_nolen(ST(1))
;
	char *  url = NULL;
	int     url_len = 0;
	LDAP *	RETVAL;
	dXSTARG;
	RETVAL = NULL;
	/* Create the LDAP URL */
	if (host && port) {
	   url_len = strlen(host) + strlen(port) + 10;
	   url = (char *)perldap_malloc(url_len);
	   snprintf(url, url_len, "ldap://%s:%s/", host, port);
	   ldap_initialize(&RETVAL, url);
	   perldap_free((void *)url);
	}
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_init_getfilter); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_init_getfilter)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fname");
    {
	char *	fname = (char *)SvPV_nolen(ST(0))
;
	LDAPFiltDesc *	RETVAL;
	dXSTARG;
#ifdef USE_OPENLDAP
	RETVAL = NULL;
#else
	RETVAL = ldap_init_getfilter(fname);
#endif
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_init_getfilter_buf); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_init_getfilter_buf)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "buf, buflen");
    {
	char *	buf = (char *)SvPV_nolen(ST(0))
;
	long	buflen = (long)SvIV(ST(1))
;
	LDAPFiltDesc *	RETVAL;
	dXSTARG;
#ifdef USE_OPENLDAP
	RETVAL = NULL;
#else
	RETVAL = ldap_init_getfilter_buf(buf,buflen);
#endif
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_is_ldap_url); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_is_ldap_url)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "url");
    {
	char *	url = (char *)SvPV_nolen(ST(0))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = ldap_is_ldap_url(url);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_memcache_destroy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_memcache_destroy)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "cache");
    {
	LDAPMemCache *	cache = INT2PTR(LDAPMemCache *,SvIV(ST(0)))
;
	/* This is a no-op when using OpenLDAP. */
#ifndef USE_OPENLDAP
	ldap_memcache_destroy(cache);
#endif
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_memcache_flush); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_memcache_flush)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "cache, dn, scope");
    {
	LDAPMemCache *	cache = INT2PTR(LDAPMemCache *,SvIV(ST(0)))
;
	char *	dn = (char *)SvPV_nolen(ST(1))
;
	int	scope = (int)SvIV(ST(2))
;
	/* This is a no-op when using OpenLDAP. */
#ifndef USE_OPENLDAP
	ldap_memcache_flush(cache, dn, scope);
#endif
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_memcache_get); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_memcache_get)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ld, cachep");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAPMemCache **	cachep;
	int	RETVAL;
	dXSTARG;
	/* This is not implemented when using OpenLDAP. */
#ifdef USE_OPENLDAP
	RETVAL = LDAP_NOT_SUPPORTED;
#else
	RETVAL = ldap_memcache_get(ld, cachep);
#endif
	sv_setiv(ST(1), PTR2IV(cachep));
	SvSETMAGIC(ST(1));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_memcache_init); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_memcache_init)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "ttl, size, baseDNs, cachep");
    {
	unsigned long	ttl = (unsigned long)SvUV(ST(0))
;
	unsigned long	size = (unsigned long)SvUV(ST(1))
;
	char **        baseDNs = (char **)avref2charptrptr(ST(2))
;
	LDAPMemCache **	cachep;
	int	RETVAL;
	dXSTARG;
	/* This is not implemented when using OpenLDAP. */
#ifdef USE_OPENLDAP
	RETVAL = LDAP_NOT_SUPPORTED;
#else
	RETVAL = ldap_memcache_init(ttl,size,baseDNs,NULL,cachep);
#endif
	sv_setiv(ST(3), PTR2IV(cachep));
	SvSETMAGIC(ST(3));
	XSprePUSH; PUSHi((IV)RETVAL);
	if (baseDNs)
	  perldap_ldap_value_free(baseDNs);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_memcache_set); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_memcache_set)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ld, cache");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAPMemCache *	cache = INT2PTR(LDAPMemCache *,SvIV(ST(1)))
;
	int	RETVAL;
	dXSTARG;
	/* This is not implemented when using OpenLDAP. */
#ifdef USE_OPENLDAP
	RETVAL = LDAP_NOT_SUPPORTED;
#else
	RETVAL = ldap_memcache_set(ld, cache);
#endif
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_memcache_update); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_memcache_update)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "cache");
    {
	LDAPMemCache *	cache = INT2PTR(LDAPMemCache *,SvIV(ST(0)))
;
	/* This is a no-op when using OpenLDAP. */
#ifndef USE_OPENLDAP
	ldap_memcache_update(cache);
#endif
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_memfree); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_memfree)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    {
	void *	p = INT2PTR(void *,SvIV(ST(0)))
;

	ldap_memfree(p);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_modify); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_modify)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ld, dn, mods");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	const char *	dn = (const char *)SvPV_nolen(ST(1))
;
	LDAPMod **	mods = hash2mod(ST(2),0,"ldap_modify");
	int	RETVAL;
	dXSTARG;
	ldap_modify_ext(ld, dn, mods, NULL, NULL, &RETVAL);
	XSprePUSH; PUSHi((IV)RETVAL);
	if (mods)
	  ldap_mods_free(mods, 1);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_modify_ext); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_modify_ext)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "ld, dn, mods, serverctrls, clientctrls, msgidp");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	const char *	dn = (const char *)SvPV_nolen(ST(1))
;
	LDAPMod **	mods = hash2mod(ST(2),0,"ldap_modify_ext");
	LDAPControl **	serverctrls = INT2PTR(LDAPControl **,SvIV(ST(3)))
;
	LDAPControl **	clientctrls = INT2PTR(LDAPControl **,SvIV(ST(4)))
;
	int	msgidp = (int)SvIV(ST(5))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = ldap_modify_ext(ld, dn, mods, serverctrls, clientctrls, &msgidp);
	sv_setiv(ST(5), (IV)msgidp);
	SvSETMAGIC(ST(5));
	XSprePUSH; PUSHi((IV)RETVAL);
	if (mods)
	  ldap_mods_free(mods, 1);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_modify_ext_s); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_modify_ext_s)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "ld, dn, mods, serverctrls, clientctrls");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	const char *	dn = (const char *)SvPV_nolen(ST(1))
;
	LDAPMod **	mods = hash2mod(ST(2),0,"ldap_modify_ext_s");
	LDAPControl **	serverctrls = INT2PTR(LDAPControl **,SvIV(ST(3)))
;
	LDAPControl **	clientctrls = INT2PTR(LDAPControl **,SvIV(ST(4)))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = ldap_modify_ext_s(ld, dn, mods, serverctrls, clientctrls);
	XSprePUSH; PUSHi((IV)RETVAL);
	if (mods)
	  ldap_mods_free(mods, 1);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_modify_s); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_modify_s)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ld, dn, mods");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	const char *	dn = (const char *)SvPV_nolen(ST(1))
;
	LDAPMod **	mods = hash2mod(ST(2), 0, "ldap_modify_s");
	int	RETVAL;
	dXSTARG;
	RETVAL = ldap_modify_ext_s(ld, dn, mods, NULL, NULL);
	XSprePUSH; PUSHi((IV)RETVAL);
	if (mods)
	  ldap_mods_free(mods, 1);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_modrdn); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_modrdn)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ld, dn, newrdn");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	const char *	dn = (const char *)SvPV_nolen(ST(1))
;
	const char *	newrdn = (const char *)SvPV_nolen(ST(2))
;
	int	RETVAL;
	dXSTARG;
	ldap_rename(ld, dn, newrdn, NULL, 1, NULL, NULL, &RETVAL);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_modrdn_s); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_modrdn_s)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ld, dn, newrdn");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	const char *	dn = (const char *)SvPV_nolen(ST(1))
;
	const char *	newrdn = (const char *)SvPV_nolen(ST(2))
;
	int	RETVAL;
	dXSTARG;
	RETVAL = ldap_rename_s(ld, dn, newrdn, NULL, 1, NULL, NULL);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_modrdn2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_modrdn2)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "ld, dn, newrdn, deleteoldrdn");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	const char *	dn = (const char *)SvPV_nolen(ST(1))
;
	const char *	newrdn = (const char *)SvPV_nolen(ST(2))
;
	int	deleteoldrdn = (int)SvIV(ST(3))
;
	int	RETVAL;
	dXSTARG;
	ldap_rename(ld, dn, newrdn, NULL, deleteoldrdn, NULL, NULL, &RETVAL);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_modrdn2_s); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_modrdn2_s)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "ld, dn, newrdn, deleteoldrdn");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	const char *	dn = (const char *)SvPV_nolen(ST(1))
;
	const char *	newrdn = (const char *)SvPV_nolen(ST(2))
;
	int	deleteoldrdn = (int)SvIV(ST(3))
;
	int	RETVAL;
	dXSTARG;
	RETVAL = ldap_rename_s(ld, dn, newrdn, NULL, deleteoldrdn, NULL, NULL);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_mods_free); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_mods_free)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "mods, freemods");
    {
	LDAPMod **	mods = INT2PTR(LDAPMod **,SvIV(ST(0)))
;
	int	freemods = (int)SvIV(ST(1))
;

	ldap_mods_free(mods, freemods);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_msgfree); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_msgfree)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "lm");
    {
	LDAPMessage *	lm = INT2PTR(LDAPMessage *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
	{
	   if (lm)
	   {
	      RETVAL = ldap_msgfree(lm);
	   } else {
	      RETVAL = LDAP_SUCCESS;
	   }
	}
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_msgid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_msgid)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "lm");
    {
	LDAPMessage *	lm = INT2PTR(LDAPMessage *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = ldap_msgid(lm);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_msgtype); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_msgtype)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "lm");
    {
	LDAPMessage *	lm = INT2PTR(LDAPMessage *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = ldap_msgtype(lm);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_multisort_entries); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_multisort_entries)
{
    dVAR; dXSARGS;
    if (items < 3)
       croak_xs_usage(cv,  "ld, chain, attr, ...");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAPMessage *	chain = INT2PTR(LDAPMessage *,SvIV(ST(1)))
;
	char **        attr = (char **)avref2charptrptr(ST(2))
;
	int	RETVAL;
	dXSTARG;
	{
	   SV		*cmp;
	   LDAP_CMP_CALLBACK		*func = &StrCaseCmp;

	   if (items > 3) {
	      cmp = ST(3);
	      if (SvROK(cmp) &&
	          (SvTYPE(SvRV(cmp)) == SVt_PVCV)) {
		 func = &internal_sortcmp_proc;
		 ldap_perl_sortcmp = cmp;
	      }
	   }
	   RETVAL = perldap_ldap_multisort_entries(ld,&chain,attr,func);
	}
	sv_setiv(ST(1), PTR2IV(chain));
	SvSETMAGIC(ST(1));
	XSprePUSH; PUSHi((IV)RETVAL);
	if (attr)
	  perldap_ldap_value_free(attr);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_next_attribute); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_next_attribute)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ld, entry, ber");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAPMessage *	entry = INT2PTR(LDAPMessage *,SvIV(ST(1)))
;
	BerElement *	ber = INT2PTR(BerElement *,SvIV(ST(2)))
;
	char *	RETVAL;
	dXSTARG;

	RETVAL = ldap_next_attribute(ld, entry, ber);
	sv_setiv(ST(2), PTR2IV(ber));
	SvSETMAGIC(ST(2));
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
	ldap_memfree(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_next_entry); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_next_entry)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ld, entry");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAPMessage *	entry = INT2PTR(LDAPMessage *,SvIV(ST(1)))
;
	LDAPMessage *	RETVAL;
	dXSTARG;

	RETVAL = ldap_next_entry(ld, entry);
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_next_message); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_next_message)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ld, msg");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAPMessage *	msg = INT2PTR(LDAPMessage *,SvIV(ST(1)))
;
	LDAPMessage *	RETVAL;
	dXSTARG;

	RETVAL = ldap_next_message(ld, msg);
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_next_reference); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_next_reference)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ld, ref");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAPMessage *	ref = INT2PTR(LDAPMessage *,SvIV(ST(1)))
;
	LDAPMessage *	RETVAL;
	dXSTARG;

	RETVAL = ldap_next_reference(ld, ref);
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_parse_entrychange_control); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_parse_entrychange_control)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "ld, ctrls, chgtypep, prevdnp, chgnumpresentp, chgnump");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAPControl **	ctrls = INT2PTR(LDAPControl **,SvIV(ST(1)))
;
	my_chgtype_t	chgtypep;
	char *	prevdnp;
	int	chgnumpresentp;
	my_chgnum_t	chgnump;
	int	RETVAL;
	dXSTARG;
	RETVAL = perldap_ldap_parse_entrychange_control(ld, ctrls, &chgtypep,
	                                  &prevdnp, &chgnumpresentp, &chgnump);
	sv_setiv(ST(2), (IV)chgtypep);
	SvSETMAGIC(ST(2));
	sv_setpv((SV*)ST(3), prevdnp);
	SvSETMAGIC(ST(3));
	sv_setiv(ST(4), (IV)chgnumpresentp);
	SvSETMAGIC(ST(4));
	sv_setiv(ST(5), (IV)chgnump);
	SvSETMAGIC(ST(5));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_parse_extended_result); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_parse_extended_result)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "ld, res, retoidp, retdatap, freeit");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAPMessage *	res = INT2PTR(LDAPMessage *,SvIV(ST(1)))
;
	char *	retoidp;
	struct berval *	retdatap;
	int	freeit = (int)SvIV(ST(4))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = ldap_parse_extended_result(ld, res, &retoidp, &retdatap, freeit);
	sv_setpv((SV*)ST(2), retoidp);
	SvSETMAGIC(ST(2));
    if (retdatap) {
        sv_setpvn(ST(3),retdatap->bv_val,retdatap->bv_len);
        ber_bvfree(retdatap);
    }
	SvSETMAGIC(ST(3));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_parse_reference); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_parse_reference)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "ld, ref, referalsp, serverctrlsp, freeit");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAPMessage *	ref = INT2PTR(LDAPMessage *,SvIV(ST(1)))
;
	char **	referalsp;
	LDAPControl **	serverctrlsp;
	int	freeit = (int)SvIV(ST(4))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = ldap_parse_reference(ld, ref, &referalsp, &serverctrlsp, freeit);
	ST(2) = charptrptr2avref(referalsp);
	SvSETMAGIC(ST(2));
	sv_setiv(ST(3), PTR2IV(serverctrlsp));
	SvSETMAGIC(ST(3));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_parse_result); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_parse_result)
{
    dVAR; dXSARGS;
    if (items != 8)
       croak_xs_usage(cv,  "ld, res, errcodep, matcheddnp, errmsgp, referralsp, serverctrlsp, freeit");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAPMessage *	res = INT2PTR(LDAPMessage *,SvIV(ST(1)))
;
	int	errcodep;
	char *	matcheddnp;
	char *	errmsgp;
	char **	referralsp;
	LDAPControl **	serverctrlsp;
	int	freeit = (int)SvIV(ST(7))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = ldap_parse_result(ld, res, &errcodep, &matcheddnp, &errmsgp, &referralsp, &serverctrlsp, freeit);
	sv_setiv(ST(2), (IV)errcodep);
	SvSETMAGIC(ST(2));
	sv_setpv((SV*)ST(3), matcheddnp);
	SvSETMAGIC(ST(3));
	sv_setpv((SV*)ST(4), errmsgp);
	SvSETMAGIC(ST(4));
	ST(5) = charptrptr2avref(referralsp);
	SvSETMAGIC(ST(5));
	sv_setiv(ST(6), PTR2IV(serverctrlsp));
	SvSETMAGIC(ST(6));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_parse_sasl_bind_result); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_parse_sasl_bind_result)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "ld, res, servercredp, freeit");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAPMessage *	res = INT2PTR(LDAPMessage *,SvIV(ST(1)))
;
	struct berval *    servercredp = NULL
;
	int	freeit = (int)SvIV(ST(3))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = ldap_parse_sasl_bind_result(ld, res, &servercredp, freeit);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_parse_sort_control); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_parse_sort_control)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "ld, ctrls, result, attribute");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAPControl **	ctrls = INT2PTR(LDAPControl **,SvIV(ST(1)))
;
	my_result_t	result;
	char *	attribute;
	int	RETVAL;
	dXSTARG;
	RETVAL = perldap_ldap_parse_sort_control(ld, ctrls, &result, &attribute);
	sv_setiv(ST(2), (IV)result);
	SvSETMAGIC(ST(2));
	sv_setpv((SV*)ST(3), attribute);
	SvSETMAGIC(ST(3));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_parse_virtuallist_control); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_parse_virtuallist_control)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "ld, ctrls, target_posp, list_sizep, errcodep");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAPControl **	ctrls = INT2PTR(LDAPControl **,SvIV(ST(1)))
;
	my_vlvint_t	target_posp;
	my_vlvint_t	list_sizep;
	int	errcodep;
	int	RETVAL;
	dXSTARG;
	RETVAL = perldap_ldap_parse_virtuallist_control(ld, ctrls, &target_posp,
	                                                &list_sizep, &errcodep);
	sv_setiv(ST(2), (IV)target_posp);
	SvSETMAGIC(ST(2));
	sv_setiv(ST(3), (IV)list_sizep);
	SvSETMAGIC(ST(3));
	sv_setiv(ST(4), (IV)errcodep);
	SvSETMAGIC(ST(4));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_perror); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_perror)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ld, s");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	const char *	s = (const char *)SvPV_nolen(ST(1))
;
	perldap_ldap_perror(ld, s);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_rename); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_rename)
{
    dVAR; dXSARGS;
    if (items != 8)
       croak_xs_usage(cv,  "ld, dn, newrdn, newparent, deleteoldrdn, serverctrls, clientctrls, msgidp");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	const char *	dn = (const char *)SvPV_nolen(ST(1))
;
	const char *	newrdn = (const char *)SvPV_nolen(ST(2))
;
	const char *	newparent = (const char *)SvPV_nolen(ST(3))
;
	int	deleteoldrdn = (int)SvIV(ST(4))
;
	LDAPControl **	serverctrls = INT2PTR(LDAPControl **,SvIV(ST(5)))
;
	LDAPControl **	clientctrls = INT2PTR(LDAPControl **,SvIV(ST(6)))
;
	int	msgidp;
	int	RETVAL;
	dXSTARG;

	RETVAL = ldap_rename(ld, dn, newrdn, newparent, deleteoldrdn, serverctrls, clientctrls, &msgidp);
	sv_setiv(ST(7), (IV)msgidp);
	SvSETMAGIC(ST(7));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_rename_s); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_rename_s)
{
    dVAR; dXSARGS;
    if (items != 7)
       croak_xs_usage(cv,  "ld, dn, newrdn, newparent, deleteoldrdn, serverctrls, clientctrls");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	const char *	dn = (const char *)SvPV_nolen(ST(1))
;
	const char *	newrdn = (const char *)SvPV_nolen(ST(2))
;
	const char *	newparent = (const char *)SvPV_nolen(ST(3))
;
	int	deleteoldrdn = (int)SvIV(ST(4))
;
	LDAPControl **	serverctrls = INT2PTR(LDAPControl **,SvIV(ST(5)))
;
	LDAPControl **	clientctrls = INT2PTR(LDAPControl **,SvIV(ST(6)))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = ldap_rename_s(ld, dn, newrdn, newparent, deleteoldrdn, serverctrls, clientctrls);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_result); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_result)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "ld, msgid, all, timeout, result");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	int	msgid = (int)SvIV(ST(1))
;
	int	all = (int)SvIV(ST(2))
;
	struct timeval	timeout;
	LDAPMessage *	result;
	int	RETVAL;
	dXSTARG;

	timeout.tv_sec = (long)atof((char *)SvPV(ST(3),PL_na));
	timeout.tv_usec = 0
;

	RETVAL = ldap_result(ld, msgid, all, &timeout, &result);
	sv_setiv(ST(4), PTR2IV(result));
	SvSETMAGIC(ST(4));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_result2error); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_result2error)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ld, r, freeit");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAPMessage *	r = INT2PTR(LDAPMessage *,SvIV(ST(1)))
;
	int	freeit = (int)SvIV(ST(2))
;
	int	RETVAL;
	dXSTARG;
	ldap_parse_result(ld, r, &RETVAL, NULL, NULL, NULL, NULL, freeit);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_sasl_bind); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_sasl_bind)
{
    dVAR; dXSARGS;
    if (items != 7)
       croak_xs_usage(cv,  "ld, dn, mechanism, cred, serverctrls, clientctrls, msgidp");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	const char *	dn = (const char *)SvPV_nolen(ST(1))
;
	const char *	mechanism = (const char *)SvPV_nolen(ST(2))
;
	struct berval	cred;
	LDAPControl **	serverctrls = INT2PTR(LDAPControl **,SvIV(ST(4)))
;
	LDAPControl **	clientctrls = INT2PTR(LDAPControl **,SvIV(ST(5)))
;
	int	msgidp;
	int	RETVAL;
	dXSTARG;

	cred.bv_val = (char *)SvPV(ST(3),PL_na);
	cred.bv_len = PL_na
;

	RETVAL = ldap_sasl_bind(ld, dn, mechanism, &cred, serverctrls, clientctrls, &msgidp);
	sv_setiv(ST(6), (IV)msgidp);
	SvSETMAGIC(ST(6));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_sasl_bind_s); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_sasl_bind_s)
{
    dVAR; dXSARGS;
    if (items != 7)
       croak_xs_usage(cv,  "ld, dn, mechanism, cred, serverctrls, clientctrls, servercredp");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	const char *	dn = (const char *)SvPV_nolen(ST(1))
;
	const char *	mechanism = (const char *)SvPV_nolen(ST(2))
;
	struct berval	cred;
	LDAPControl **	serverctrls = INT2PTR(LDAPControl **,SvIV(ST(4)))
;
	LDAPControl **	clientctrls = INT2PTR(LDAPControl **,SvIV(ST(5)))
;
	struct berval *    servercredp = NULL
;
	int	RETVAL;
	dXSTARG;

	cred.bv_val = (char *)SvPV(ST(3),PL_na);
	cred.bv_len = PL_na
;

	RETVAL = ldap_sasl_bind_s(ld, dn, mechanism, &cred, serverctrls, clientctrls, &servercredp);
    if (servercredp) {
        sv_setpvn(ST(6),servercredp->bv_val,servercredp->bv_len);
        ber_bvfree(servercredp);
    }
	SvSETMAGIC(ST(6));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_search); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_search)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "ld, base, scope, filter, attrs, attrsonly");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	const char *	base = (const char *)SvPV_nolen(ST(1))
;
	int	scope = (int)SvIV(ST(2))
;
	const char *	filter = (const char *)SvPV_nolen(ST(3))
;
	char **        attrs = (char **)avref2charptrptr(ST(4))
;
	int	attrsonly = (int)SvIV(ST(5))
;
	int	RETVAL;
	dXSTARG;
	ldap_search_ext(ld, base, scope, filter, attrs,
	                attrsonly, NULL, NULL, NULL, 0, &RETVAL);
	XSprePUSH; PUSHi((IV)RETVAL);
	if (attrs)
	  perldap_ldap_value_free(attrs);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_search_ext); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_search_ext)
{
    dVAR; dXSARGS;
    if (items != 11)
       croak_xs_usage(cv,  "ld, base, scope, filter, attrs, attrsonly, serverctrls, clientctrls, timeoutp, sizelimit, msgidp");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	const char *	base = (const char *)SvPV_nolen(ST(1))
;
	int	scope = (int)SvIV(ST(2))
;
	const char *	filter = (const char *)SvPV_nolen(ST(3))
;
	char **        attrs = (char **)avref2charptrptr(ST(4))
;
	int	attrsonly = (int)SvIV(ST(5))
;
	LDAPControl **	serverctrls = INT2PTR(LDAPControl **,SvIV(ST(6)))
;
	LDAPControl **	clientctrls = INT2PTR(LDAPControl **,SvIV(ST(7)))
;
	struct timeval	timeoutp;
	int	sizelimit = (int)SvIV(ST(9))
;
	int	msgidp;
	int	RETVAL;
	dXSTARG;

	timeoutp.tv_sec = (long)atof((char *)SvPV(ST(8),PL_na));
	timeoutp.tv_usec = 0
;

	RETVAL = ldap_search_ext(ld, base, scope, filter, attrs, attrsonly, serverctrls, clientctrls, &timeoutp, sizelimit, &msgidp);
	sv_setiv(ST(10), (IV)msgidp);
	SvSETMAGIC(ST(10));
	XSprePUSH; PUSHi((IV)RETVAL);
	if (attrs)
	  perldap_ldap_value_free(attrs);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_search_ext_s); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_search_ext_s)
{
    dVAR; dXSARGS;
    if (items != 11)
       croak_xs_usage(cv,  "ld, base, scope, filter, attrs, attrsonly, serverctrls, clientctrls, timeoutp, sizelimit, res");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	const char *	base = (const char *)SvPV_nolen(ST(1))
;
	int	scope = (int)SvIV(ST(2))
;
	const char *	filter = (const char *)SvPV_nolen(ST(3))
;
	char **        attrs = (char **)avref2charptrptr(ST(4))
;
	int	attrsonly = (int)SvIV(ST(5))
;
	LDAPControl **	serverctrls = INT2PTR(LDAPControl **,SvIV(ST(6)))
;
	LDAPControl **	clientctrls = INT2PTR(LDAPControl **,SvIV(ST(7)))
;
	struct timeval	timeoutp;
	int	sizelimit = (int)SvIV(ST(9))
;
	LDAPMessage *	res;
	int	RETVAL;
	dXSTARG;

	timeoutp.tv_sec = (long)atof((char *)SvPV(ST(8),PL_na));
	timeoutp.tv_usec = 0
;

	RETVAL = ldap_search_ext_s(ld, base, scope, filter, attrs, attrsonly, serverctrls, clientctrls, &timeoutp, sizelimit, &res);
	sv_setiv(ST(10), PTR2IV(res));
	SvSETMAGIC(ST(10));
	XSprePUSH; PUSHi((IV)RETVAL);
	if (attrs)
	  perldap_ldap_value_free(attrs);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_search_s); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_search_s)
{
    dVAR; dXSARGS;
    if (items != 7)
       croak_xs_usage(cv,  "ld, base, scope, filter, attrs, attrsonly, res");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	const char *	base = (const char *)SvPV_nolen(ST(1))
;
	int	scope = (int)SvIV(ST(2))
;
	const char *	filter = (const char *)SvPV_nolen(ST(3))
;
	char **        attrs = (char **)avref2charptrptr(ST(4))
;
	int	attrsonly = (int)SvIV(ST(5))
;
	LDAPMessage *	res;
	int	RETVAL;
	dXSTARG;
	RETVAL = ldap_search_ext_s(ld, base, scope, filter, attrs, attrsonly,
	                           NULL, NULL, NULL, 0, &res);
	sv_setiv(ST(6), PTR2IV(res));
	SvSETMAGIC(ST(6));
	XSprePUSH; PUSHi((IV)RETVAL);
	if (attrs)
	  perldap_ldap_value_free(attrs);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_search_st); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_search_st)
{
    dVAR; dXSARGS;
    if (items != 8)
       croak_xs_usage(cv,  "ld, base, scope, filter, attrs, attrsonly, timeout, res");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	const char *	base = (const char *)SvPV_nolen(ST(1))
;
	int	scope = (int)SvIV(ST(2))
;
	const char *	filter = (const char *)SvPV_nolen(ST(3))
;
	char **        attrs = (char **)avref2charptrptr(ST(4))
;
	int	attrsonly = (int)SvIV(ST(5))
;
	struct timeval	timeout;
	LDAPMessage *	res;
	int	RETVAL;
	dXSTARG;

	timeout.tv_sec = (long)atof((char *)SvPV(ST(6),PL_na));
	timeout.tv_usec = 0
;
	RETVAL = ldap_search_ext_s(ld, base, scope, filter, attrs,
	                           attrsonly, NULL, NULL, &timeout, 0, &res);
	sv_setiv(ST(7), PTR2IV(res));
	SvSETMAGIC(ST(7));
	XSprePUSH; PUSHi((IV)RETVAL);
	if (attrs)
	  perldap_ldap_value_free(attrs);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_set_filter_additions); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_set_filter_additions)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "lfdp, prefix, suffix");
    {
	LDAPFiltDesc *	lfdp = INT2PTR(LDAPFiltDesc *,SvIV(ST(0)))
;
	char *	prefix = (char *)SvPV_nolen(ST(1))
;
	char *	suffix = (char *)SvPV_nolen(ST(2))
;
	int	RETVAL;
	dXSTARG;
	/* This is not implemented when using OpenLDAP. */
#ifdef USE_OPENLDAP
	RETVAL = LDAP_NOT_SUPPORTED;
#else
	RETVAL = ldap_set_filter_additions(lfdp, prefix, suffix);
#endif
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_set_lderrno); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_set_lderrno)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "ld, e, m, s");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	int	e = (int)SvIV(ST(1))
;
	char *	m = (char *)SvPV_nolen(ST(2))
;
	char *	s = (char *)SvPV_nolen(ST(3))
;
	int	RETVAL;
	dXSTARG;
	RETVAL = perldap_ldap_set_lderrno(ld, e, m, s);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_set_option); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_set_option)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ld, option, optdata");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	int	option = (int)SvIV(ST(1))
;
	int	optdata = (int)SvIV(ST(2))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = ldap_set_option(ld, option, &optdata);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_set_rebind_proc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_set_rebind_proc)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ld, rebindproc");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	SV *	rebindproc = ST(1)
;
	{
	   if (SvTYPE(SvRV(rebindproc)) != SVt_PVCV)
	   {
	      ldap_set_rebind_proc(ld,NULL,NULL);
	   } else {
	      if (ldap_perl_rebindproc == (SV*)NULL)
	         ldap_perl_rebindproc = newSVsv(rebindproc);
	      else
	         SvSetSV(ldap_perl_rebindproc,rebindproc);
	      ldap_set_rebind_proc(ld,&internal_rebind_proc,NULL);
	   }
	}
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_set_default_rebind_proc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_set_default_rebind_proc)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "ld, dn, pwd, auth");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	char *	dn = (char *)SvPV_nolen(ST(1))
;
	char *	pwd = (char *)SvPV_nolen(ST(2))
;
	int	auth = (int)SvIV(ST(3))
;
        {
          if ( ldap_default_rebind_dn != NULL )
          {
             Safefree(ldap_default_rebind_dn);
             ldap_default_rebind_dn = NULL;
          }
          if ( ldap_default_rebind_pwd != NULL )
          {
             Safefree(ldap_default_rebind_pwd);
             ldap_default_rebind_pwd = NULL;
          }
          ldap_default_rebind_dn = StrDup(dn);
          ldap_default_rebind_pwd = StrDup(pwd);
          ldap_default_rebind_auth = auth;

          ldap_set_rebind_proc(ld,&ldap_default_rebind_proc,NULL);
        }
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_simple_bind); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_simple_bind)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ld, who, passwd");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	const char *	who = (const char *)SvPV_nolen(ST(1))
;
	char *	passwd = (char *)SvPV_nolen(ST(2))
;
	struct berval	cred;
	int	RETVAL;
	dXSTARG;
	cred.bv_val = passwd;
	cred.bv_len = strlen(passwd);

	ldap_sasl_bind(ld, who, LDAP_SASL_SIMPLE,
	               &cred, NULL, NULL, &RETVAL);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_simple_bind_s); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_simple_bind_s)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ld, who, passwd");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	const char *	who = (const char *)SvPV_nolen(ST(1))
;
	char *	passwd = (char *)SvPV_nolen(ST(2))
;
	struct berval	cred;
	int	RETVAL;
	dXSTARG;
	cred.bv_val = passwd;
	cred.bv_len = strlen(passwd);

	RETVAL = ldap_sasl_bind_s(ld, who, LDAP_SASL_SIMPLE,
	                          &cred, NULL, NULL, NULL);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_sort_entries); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_sort_entries)
{
    dVAR; dXSARGS;
    if (items < 3)
       croak_xs_usage(cv,  "ld, chain, attr, ...");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAPMessage *	chain = INT2PTR(LDAPMessage *,SvIV(ST(1)))
;
	char *	attr = (char *)SvPV_nolen(ST(2))
;
	int	RETVAL;
	dXSTARG;
	{
	   SV		*cmp;
	   LDAP_CMP_CALLBACK		*func = &StrCaseCmp;

	   if (items > 3) {
	      cmp = ST(3);
	      if (SvROK(cmp) &&
	          (SvTYPE(SvRV(cmp)) == SVt_PVCV)) {
	         func = &internal_sortcmp_proc;
	         ldap_perl_sortcmp = cmp;
	      }
	   }
	   RETVAL = perldap_ldap_sort_entries(ld,&chain,attr,func);
	}
	sv_setiv(ST(1), PTR2IV(chain));
	SvSETMAGIC(ST(1));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_unbind); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_unbind)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ld");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
	RETVAL = ldap_unbind_ext(ld, NULL, NULL);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_unbind_s); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_unbind_s)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ld");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
	RETVAL = ldap_unbind_ext_s(ld, NULL, NULL);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_url_parse); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_url_parse)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "url");
    {
	char *	url = (char *)SvPV_nolen(ST(0))
;
	SV *	RETVAL;
        {
	   LDAPURLDesc *realcomp;
	   int count,ret;

	   HV*   FullHash = newHV();
	   RETVAL = newRV((SV*)FullHash);

	   ret = ldap_url_parse(url,&realcomp);
	   if (ret == 0)
	   {
	      static char *host_key = "host";
	      static char *port_key = "port";
	      static char *dn_key = "dn";
	      static char *attr_key = "attr";
	      static char *scope_key = "scope";
	      static char *filter_key = "filter";
#ifdef USE_OPENLDAP
              static char *scheme_key = "scheme";
              static char *exts_key = "exts";
              static char *crit_exts_key = "crit_exts";
              SV* scheme = newSVpv(realcomp->lud_scheme,0);
              SV* crit_exts = newSViv(realcomp->lud_crit_exts);
              AV* extsarray = newAV();
              SV* extsref = newRV((SV*) extsarray);
#else
	      static char *options_key = "options";
	      SV* options = newSViv(realcomp->lud_options);
#endif
	      SV* host; /* = newSVpv(realcomp->lud_host,0); */
	      SV* port = newSViv(realcomp->lud_port);
	      SV* dn; /* = newSVpv(realcomp->lud_dn,0); */
	      SV* scope = newSViv(realcomp->lud_scope);
	      SV* filter = newSVpv(realcomp->lud_filter,0);
	      AV* attrarray = newAV();
	      SV* attribref = newRV((SV*) attrarray);

	      if (realcomp->lud_host)
	         host = newSVpv(realcomp->lud_host,0);
	      else
	         host = newSVpv("",0);

	      if (realcomp->lud_dn)
	         dn = newSVpv(realcomp->lud_dn,0);
	      else
	         dn = newSVpv("",0);

	      if (realcomp->lud_attrs != NULL)
	      {
	         for (count=0; realcomp->lud_attrs[count] != NULL; count++)
	         {
	            SV* SVval = newSVpv(realcomp->lud_attrs[count],0);
	            av_push(attrarray, SVval);
	         }
	      }
#ifdef USE_OPENLDAP
	      if (realcomp->lud_exts != NULL)
	      {
	         for (count=0; realcomp->lud_exts[count] != NULL; count++)
	         {
	            SV* SVval = newSVpv(realcomp->lud_exts[count],0);
	            av_push(extsarray, SVval);
	         }
	      }
#endif
	      hv_store(FullHash,host_key,strlen(host_key),host,0);
	      hv_store(FullHash,port_key,strlen(port_key),port,0);
	      hv_store(FullHash,dn_key,strlen(dn_key),dn,0);
	      hv_store(FullHash,attr_key,strlen(attr_key),attribref,0);
	      hv_store(FullHash,scope_key,strlen(scope_key),scope,0);
	      hv_store(FullHash,filter_key,strlen(filter_key),filter,0);
#ifdef USE_OPENLDAP
	      hv_store(FullHash,scheme_key,strlen(scheme_key),scheme,0);
	      hv_store(FullHash,exts_key,strlen(exts_key),extsref,0);
	      hv_store(FullHash,crit_exts_key,strlen(crit_exts_key),crit_exts,0);
#else
	      hv_store(FullHash,options_key,strlen(options_key),options,0);
#endif
	      ldap_free_urldesc(realcomp);
	   } else {
	      RETVAL = &PL_sv_undef;
	   }
	}
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_url_search); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_url_search)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ld, url, attrsonly");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	char *	url = (char *)SvPV_nolen(ST(1))
;
	int	attrsonly = (int)SvIV(ST(2))
;
	int	RETVAL;
	dXSTARG;
	RETVAL = perldap_ldap_url_search(ld, url, attrsonly);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_url_search_s); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_url_search_s)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "ld, url, attrsonly, res");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	char *	url = (char *)SvPV_nolen(ST(1))
;
	int	attrsonly = (int)SvIV(ST(2))
;
	LDAPMessage *	res = INT2PTR(LDAPMessage *,SvIV(ST(3)))
;
	int	RETVAL;
	dXSTARG;
	RETVAL = perldap_ldap_url_search_s(ld, url, attrsonly, &res);
	sv_setiv(ST(3), PTR2IV(res));
	SvSETMAGIC(ST(3));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_url_search_st); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_url_search_st)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "ld, url, attrsonly, timeout, res");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	char *	url = (char *)SvPV_nolen(ST(1))
;
	int	attrsonly = (int)SvIV(ST(2))
;
	struct timeval	timeout;
	LDAPMessage *	res = INT2PTR(LDAPMessage *,SvIV(ST(4)))
;
	int	RETVAL;
	dXSTARG;

	timeout.tv_sec = (long)atof((char *)SvPV(ST(3),PL_na));
	timeout.tv_usec = 0
;
	RETVAL = perldap_ldap_url_search_st(ld, url, attrsonly, &timeout, &res);
	sv_setiv(ST(4), PTR2IV(res));
	SvSETMAGIC(ST(4));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_version); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_version)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ver");
    {
	LDAPVersion *	ver = INT2PTR(LDAPVersion *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
	/* This is a no-op when using OpenLDAP. */
#ifdef USE_OPENLDAP
	RETVAL = 0;
#else
	RETVAL = ldap_version(ver);
#endif
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef USE_SSL
#define XSubPPtmpAAAB 1


XS_EUPXS(XS_Mozilla__LDAP__API_ldapssl_client_init); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldapssl_client_init)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "certdbpath, certdbhandle");
    {
	const char *	certdbpath = (const char *)SvPV_nolen(ST(0))
;
	void *	certdbhandle = INT2PTR(void *,SvIV(ST(1)))
;
	int	RETVAL;
	dXSTARG;
	RETVAL = perldap_ldapssl_client_init(certdbpath, certdbhandle);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldapssl_clientauth_init); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldapssl_clientauth_init)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "certdbpath, certdbhandle, needkeydb, keydbpath, keydbhandle");
    {
	char *	certdbpath = (char *)SvPV_nolen(ST(0))
;
	void *	certdbhandle = INT2PTR(void *,SvIV(ST(1)))
;
	int	needkeydb = (int)SvIV(ST(2))
;
	char *	keydbpath = (char *)SvPV_nolen(ST(3))
;
	void *	keydbhandle = INT2PTR(void *,SvIV(ST(4)))
;
	int	RETVAL;
	dXSTARG;
	/* This is a no-op when using OpenLDAP. */
#ifdef USE_OPENLDAP
	RETVAL = 0;
#else
	RETVAL = ldapssl_clientauth_init(certdbpath,certdbhandle,needkeydb,keydbpath,keydbhandle);
#endif
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldapssl_enable_clientauth); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldapssl_enable_clientauth)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "ld, keynickname, keypasswd, certnickname");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	char *	keynickname = (char *)SvPV_nolen(ST(1))
;
	char *	keypasswd = (char *)SvPV_nolen(ST(2))
;
	char *	certnickname = (char *)SvPV_nolen(ST(3))
;
	int	RETVAL;
	dXSTARG;
	RETVAL = perldap_ldapssl_enable_clientauth(ld, keynickname, keypasswd, certnickname);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldapssl_init); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldapssl_init)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "host, port, secure");
    {
	const char *	host = (const char *)SvPV_nolen(ST(0))
;
	const char *	port = (const char *)SvPV_nolen(ST(1))
;
	int	secure = (int)SvIV(ST(2))
;
	LDAP *	RETVAL;
	dXSTARG;
	RETVAL = perldap_ldapssl_init(host,port,secure);
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldapssl_install_routines); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldapssl_install_routines)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ld");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	int	RETVAL;
	dXSTARG;
	/* This is a no-op when using OpenLDAP. */
#ifdef USE_OPENLDAP
	RETVAL = 0;
#else
	RETVAL = ldapssl_install_routines(ld);
#endif
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldap_start_tls_s); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldap_start_tls_s)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ld, serverctrls, clientctrls");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	LDAPControl **	serverctrls = INT2PTR(LDAPControl **,SvIV(ST(1)))
;
	LDAPControl **	clientctrls = INT2PTR(LDAPControl **,SvIV(ST(2)))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = ldap_start_tls_s(ld, serverctrls, clientctrls);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldapssl_err2string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldapssl_err2string)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "prerrno");
    {
	const int	prerrno = (const int)SvIV(ST(0))
;
	const char *	RETVAL;
	dXSTARG;
	/* We just return "Unknown error." when using OpenLDAP.  This
	 * is the same string that MozLDAP returns when it has a problem
	 * getting the error string. */
#ifdef USE_OPENLDAP
	RETVAL = "Unknown error.";
#else
	RETVAL = ldapssl_err2string(prerrno);
#endif
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_ldapssl_set_strength); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_ldapssl_set_strength)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ld, sslstrength");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	int	sslstrength = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;
	/* This is not implemented when using OpenLDAP. */
#ifdef USE_OPENLDAP
        RETVAL = -1;
#else
	RETVAL = ldapssl_set_strength(ld, sslstrength);
#endif
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#endif
#ifdef PRLDAP
#ifndef USE_OPENLDAP
#include <ldappr.h>
#endif
#define XSubPPtmpAAAC 1


XS_EUPXS(XS_Mozilla__LDAP__API_prldap_install_routines); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_prldap_install_routines)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ld, shared");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	int	shared = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;
#ifdef USE_OPENLDAP
	RETVAL = 0;
#else
	RETVAL = prldap_install_routines(ld, shared);
#endif
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Mozilla__LDAP__API_prldap_set_session_option); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Mozilla__LDAP__API_prldap_set_session_option)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "ld, sessionarg, option, optdata");
    {
	LDAP *	ld = INT2PTR(LDAP *,SvIV(ST(0)))
;
	void *	sessionarg = INT2PTR(void *,SvIV(ST(1)))
;
	int	option = (int)SvIV(ST(2))
;
	int	optdata = (int)SvIV(ST(3))
;
	int	RETVAL;
	dXSTARG;
#ifdef USE_OPENLDAP
	RETVAL = 0;
#else
	RETVAL = prldap_set_session_option(ld, sessionarg, option, optdata);
#endif
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#endif  /* PRLDAP */
#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Mozilla__LDAP__API); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Mozilla__LDAP__API)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        (void)newXSproto_portable("Mozilla::LDAP::API::constant", XS_Mozilla__LDAP__API_constant, file, "$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_abandon", XS_Mozilla__LDAP__API_ldap_abandon, file, "$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_abandon_ext", XS_Mozilla__LDAP__API_ldap_abandon_ext, file, "$$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_add", XS_Mozilla__LDAP__API_ldap_add, file, "$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_add_ext", XS_Mozilla__LDAP__API_ldap_add_ext, file, "$$$$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_add_ext_s", XS_Mozilla__LDAP__API_ldap_add_ext_s, file, "$$$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_add_s", XS_Mozilla__LDAP__API_ldap_add_s, file, "$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_ber_free", XS_Mozilla__LDAP__API_ldap_ber_free, file, "$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_bind", XS_Mozilla__LDAP__API_ldap_bind, file, "$$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_bind_s", XS_Mozilla__LDAP__API_ldap_bind_s, file, "$$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_compare", XS_Mozilla__LDAP__API_ldap_compare, file, "$$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_compare_ext", XS_Mozilla__LDAP__API_ldap_compare_ext, file, "$$$$$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_compare_ext_s", XS_Mozilla__LDAP__API_ldap_compare_ext_s, file, "$$$$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_compare_s", XS_Mozilla__LDAP__API_ldap_compare_s, file, "$$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_control_free", XS_Mozilla__LDAP__API_ldap_control_free, file, "$");
#if XSubPPtmpAAAA
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_controls_count", XS_Mozilla__LDAP__API_ldap_controls_count, file, "$");
#endif
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_controls_free", XS_Mozilla__LDAP__API_ldap_controls_free, file, "$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_count_entries", XS_Mozilla__LDAP__API_ldap_count_entries, file, "$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_count_messages", XS_Mozilla__LDAP__API_ldap_count_messages, file, "$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_count_references", XS_Mozilla__LDAP__API_ldap_count_references, file, "$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_create_filter", XS_Mozilla__LDAP__API_ldap_create_filter, file, "$$$$$$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_create_persistentsearch_control", XS_Mozilla__LDAP__API_ldap_create_persistentsearch_control, file, "$$$$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_create_sort_control", XS_Mozilla__LDAP__API_ldap_create_sort_control, file, "$$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_create_sort_keylist", XS_Mozilla__LDAP__API_ldap_create_sort_keylist, file, "$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_create_virtuallist_control", XS_Mozilla__LDAP__API_ldap_create_virtuallist_control, file, "$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_delete", XS_Mozilla__LDAP__API_ldap_delete, file, "$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_delete_ext", XS_Mozilla__LDAP__API_ldap_delete_ext, file, "$$$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_delete_ext_s", XS_Mozilla__LDAP__API_ldap_delete_ext_s, file, "$$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_delete_s", XS_Mozilla__LDAP__API_ldap_delete_s, file, "$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_dn2ufn", XS_Mozilla__LDAP__API_ldap_dn2ufn, file, "$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_err2string", XS_Mozilla__LDAP__API_ldap_err2string, file, "$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_explode_dn", XS_Mozilla__LDAP__API_ldap_explode_dn, file, "$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_explode_rdn", XS_Mozilla__LDAP__API_ldap_explode_rdn, file, "$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_extended_operation", XS_Mozilla__LDAP__API_ldap_extended_operation, file, "$$$$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_extended_operation_s", XS_Mozilla__LDAP__API_ldap_extended_operation_s, file, "$$$$$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_first_attribute", XS_Mozilla__LDAP__API_ldap_first_attribute, file, "$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_first_entry", XS_Mozilla__LDAP__API_ldap_first_entry, file, "$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_first_message", XS_Mozilla__LDAP__API_ldap_first_message, file, "$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_first_reference", XS_Mozilla__LDAP__API_ldap_first_reference, file, "$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_free_friendlymap", XS_Mozilla__LDAP__API_ldap_free_friendlymap, file, "$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_free_sort_keylist", XS_Mozilla__LDAP__API_ldap_free_sort_keylist, file, "$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_free_urldesc", XS_Mozilla__LDAP__API_ldap_free_urldesc, file, "$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_friendly_name", XS_Mozilla__LDAP__API_ldap_friendly_name, file, "$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_get_dn", XS_Mozilla__LDAP__API_ldap_get_dn, file, "$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_get_entry_controls", XS_Mozilla__LDAP__API_ldap_get_entry_controls, file, "$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_getfilter_free", XS_Mozilla__LDAP__API_ldap_getfilter_free, file, "$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_getfirstfilter", XS_Mozilla__LDAP__API_ldap_getfirstfilter, file, "$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_get_lang_values", XS_Mozilla__LDAP__API_ldap_get_lang_values, file, "$$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_get_lang_values_len", XS_Mozilla__LDAP__API_ldap_get_lang_values_len, file, "$$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_get_lderrno", XS_Mozilla__LDAP__API_ldap_get_lderrno, file, "$;@");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_getnextfilter", XS_Mozilla__LDAP__API_ldap_getnextfilter, file, "$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_get_option", XS_Mozilla__LDAP__API_ldap_get_option, file, "$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_get_values", XS_Mozilla__LDAP__API_ldap_get_values, file, "$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_get_values_len", XS_Mozilla__LDAP__API_ldap_get_values_len, file, "$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_init", XS_Mozilla__LDAP__API_ldap_init, file, "$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_init_getfilter", XS_Mozilla__LDAP__API_ldap_init_getfilter, file, "$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_init_getfilter_buf", XS_Mozilla__LDAP__API_ldap_init_getfilter_buf, file, "$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_is_ldap_url", XS_Mozilla__LDAP__API_ldap_is_ldap_url, file, "$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_memcache_destroy", XS_Mozilla__LDAP__API_ldap_memcache_destroy, file, "$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_memcache_flush", XS_Mozilla__LDAP__API_ldap_memcache_flush, file, "$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_memcache_get", XS_Mozilla__LDAP__API_ldap_memcache_get, file, "$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_memcache_init", XS_Mozilla__LDAP__API_ldap_memcache_init, file, "$$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_memcache_set", XS_Mozilla__LDAP__API_ldap_memcache_set, file, "$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_memcache_update", XS_Mozilla__LDAP__API_ldap_memcache_update, file, "$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_memfree", XS_Mozilla__LDAP__API_ldap_memfree, file, "$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_modify", XS_Mozilla__LDAP__API_ldap_modify, file, "$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_modify_ext", XS_Mozilla__LDAP__API_ldap_modify_ext, file, "$$$$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_modify_ext_s", XS_Mozilla__LDAP__API_ldap_modify_ext_s, file, "$$$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_modify_s", XS_Mozilla__LDAP__API_ldap_modify_s, file, "$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_modrdn", XS_Mozilla__LDAP__API_ldap_modrdn, file, "$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_modrdn_s", XS_Mozilla__LDAP__API_ldap_modrdn_s, file, "$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_modrdn2", XS_Mozilla__LDAP__API_ldap_modrdn2, file, "$$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_modrdn2_s", XS_Mozilla__LDAP__API_ldap_modrdn2_s, file, "$$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_mods_free", XS_Mozilla__LDAP__API_ldap_mods_free, file, "$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_msgfree", XS_Mozilla__LDAP__API_ldap_msgfree, file, "$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_msgid", XS_Mozilla__LDAP__API_ldap_msgid, file, "$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_msgtype", XS_Mozilla__LDAP__API_ldap_msgtype, file, "$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_multisort_entries", XS_Mozilla__LDAP__API_ldap_multisort_entries, file, "$$$;@");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_next_attribute", XS_Mozilla__LDAP__API_ldap_next_attribute, file, "$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_next_entry", XS_Mozilla__LDAP__API_ldap_next_entry, file, "$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_next_message", XS_Mozilla__LDAP__API_ldap_next_message, file, "$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_next_reference", XS_Mozilla__LDAP__API_ldap_next_reference, file, "$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_parse_entrychange_control", XS_Mozilla__LDAP__API_ldap_parse_entrychange_control, file, "$$$$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_parse_extended_result", XS_Mozilla__LDAP__API_ldap_parse_extended_result, file, "$$$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_parse_reference", XS_Mozilla__LDAP__API_ldap_parse_reference, file, "$$$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_parse_result", XS_Mozilla__LDAP__API_ldap_parse_result, file, "$$$$$$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_parse_sasl_bind_result", XS_Mozilla__LDAP__API_ldap_parse_sasl_bind_result, file, "$$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_parse_sort_control", XS_Mozilla__LDAP__API_ldap_parse_sort_control, file, "$$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_parse_virtuallist_control", XS_Mozilla__LDAP__API_ldap_parse_virtuallist_control, file, "$$$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_perror", XS_Mozilla__LDAP__API_ldap_perror, file, "$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_rename", XS_Mozilla__LDAP__API_ldap_rename, file, "$$$$$$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_rename_s", XS_Mozilla__LDAP__API_ldap_rename_s, file, "$$$$$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_result", XS_Mozilla__LDAP__API_ldap_result, file, "$$$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_result2error", XS_Mozilla__LDAP__API_ldap_result2error, file, "$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_sasl_bind", XS_Mozilla__LDAP__API_ldap_sasl_bind, file, "$$$$$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_sasl_bind_s", XS_Mozilla__LDAP__API_ldap_sasl_bind_s, file, "$$$$$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_search", XS_Mozilla__LDAP__API_ldap_search, file, "$$$$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_search_ext", XS_Mozilla__LDAP__API_ldap_search_ext, file, "$$$$$$$$$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_search_ext_s", XS_Mozilla__LDAP__API_ldap_search_ext_s, file, "$$$$$$$$$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_search_s", XS_Mozilla__LDAP__API_ldap_search_s, file, "$$$$$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_search_st", XS_Mozilla__LDAP__API_ldap_search_st, file, "$$$$$$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_set_filter_additions", XS_Mozilla__LDAP__API_ldap_set_filter_additions, file, "$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_set_lderrno", XS_Mozilla__LDAP__API_ldap_set_lderrno, file, "$$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_set_option", XS_Mozilla__LDAP__API_ldap_set_option, file, "$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_set_rebind_proc", XS_Mozilla__LDAP__API_ldap_set_rebind_proc, file, "$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_set_default_rebind_proc", XS_Mozilla__LDAP__API_ldap_set_default_rebind_proc, file, "$$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_simple_bind", XS_Mozilla__LDAP__API_ldap_simple_bind, file, "$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_simple_bind_s", XS_Mozilla__LDAP__API_ldap_simple_bind_s, file, "$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_sort_entries", XS_Mozilla__LDAP__API_ldap_sort_entries, file, "$$$;@");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_unbind", XS_Mozilla__LDAP__API_ldap_unbind, file, "$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_unbind_s", XS_Mozilla__LDAP__API_ldap_unbind_s, file, "$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_url_parse", XS_Mozilla__LDAP__API_ldap_url_parse, file, "$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_url_search", XS_Mozilla__LDAP__API_ldap_url_search, file, "$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_url_search_s", XS_Mozilla__LDAP__API_ldap_url_search_s, file, "$$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_url_search_st", XS_Mozilla__LDAP__API_ldap_url_search_st, file, "$$$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_version", XS_Mozilla__LDAP__API_ldap_version, file, "$");
#if XSubPPtmpAAAB
        (void)newXSproto_portable("Mozilla::LDAP::API::ldapssl_client_init", XS_Mozilla__LDAP__API_ldapssl_client_init, file, "$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldapssl_clientauth_init", XS_Mozilla__LDAP__API_ldapssl_clientauth_init, file, "$$$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldapssl_enable_clientauth", XS_Mozilla__LDAP__API_ldapssl_enable_clientauth, file, "$$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldapssl_init", XS_Mozilla__LDAP__API_ldapssl_init, file, "$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldapssl_install_routines", XS_Mozilla__LDAP__API_ldapssl_install_routines, file, "$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldap_start_tls_s", XS_Mozilla__LDAP__API_ldap_start_tls_s, file, "$$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldapssl_err2string", XS_Mozilla__LDAP__API_ldapssl_err2string, file, "$");
        (void)newXSproto_portable("Mozilla::LDAP::API::ldapssl_set_strength", XS_Mozilla__LDAP__API_ldapssl_set_strength, file, "$$");
#endif
#if XSubPPtmpAAAC
        (void)newXSproto_portable("Mozilla::LDAP::API::prldap_install_routines", XS_Mozilla__LDAP__API_prldap_install_routines, file, "$$");
        (void)newXSproto_portable("Mozilla::LDAP::API::prldap_set_session_option", XS_Mozilla__LDAP__API_prldap_set_session_option, file, "$$$$");
#endif

    /* Initialisation Section */

if ( perldap_init() != 0)
{
   fprintf(stderr, "Error loading Mozilla::LDAP::API: perldap_init failed\n");
   exit(1);
}

#if XSubPPtmpAAAA
#endif
#if XSubPPtmpAAAB
#endif
#if XSubPPtmpAAAC
#endif

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

